//
//  Copyright (C) by S.Tomabechi 1994
//  All rights reserved.
//
//  calculate (3)
//
//  Roger Apery θˤ
//
//  (3)=5/2(-1)^(n-1)/(n^3*C(2n,n))
//
//    C(2n,n)=(2n)!/(n!*n!)
//

#include "Fint.hpp"

Fint zeta3(int precision)
{
  precision=GetPrecision()>precision ? GetPrecision():precision ;

  Fint zt(precision+1,precision),
       c5(precision+1,precision) ;
  zt=0 ;
  c5=5 ;
  Mint cb(1) ;
  Mint n(0) ;
  Fint w ;
  do {
    ++n ;
    cb=(2*cb*(2*n-1))/n ;
    w=c5/(2*cb*n*n*n) ;
    zt+=w ;
    ++n ;
    cb=(2*cb*(2*n-1))/n ;
    w=c5/(2*cb*n*n*n) ;
    zt-=w ;
  } while( w!=0 ) ;

  return zt ;
}
