#
#	Copyright (C) S.Tomabchi 2001
#
#	make library
#
LIBPATH = ../lib
SRCPATH = ../source/lib
CC = g++
NASM = nasm
TLIB = tlib
TLINK = g++
INCLUDE = ../include
AFLAGS = -f elf -i../include/ -o $@ #	for Windows
CFLAGS = -c -I../include -o $@

.c.o:
	  $(CC) {$< }

.cpp.o:
	  $(CC) -c {$< }
.asm.o:
	  $(NASM) $(AFLAGS)	 {$< }


OBJS =	$(LIBPATH)/addm.o\
	$(LIBPATH)/addsubul.o\
	$(LIBPATH)/addul.o\
	$(LIBPATH)/agcd.o\
	$(LIBPATH)/allocf.o\
	$(LIBPATH)/amodl.o\
	$(LIBPATH)/amodul.o\
	$(LIBPATH)/apowmod.o\
	$(LIBPATH)/aprcl.o\
	$(LIBPATH)/asrtfail.o\
	$(LIBPATH)/assignf.o\
	$(LIBPATH)/assignfd.o\
	$(LIBPATH)/assignfl.o\
	$(LIBPATH)/assignl.o\
	$(LIBPATH)/assignm.o\
	$(LIBPATH)/assignmc.o\
	$(LIBPATH)/assignul.o\
	$(LIBPATH)/atan.o\
	$(LIBPATH)/bitand.o\
	$(LIBPATH)/bitindex.o\
	$(LIBPATH)/bitoff.o\
	$(LIBPATH)/biton.o\
	$(LIBPATH)/bitor.o\
	$(LIBPATH)/bitout.o\
	$(LIBPATH)/bitread.o\
	$(LIBPATH)/bitrvrs.o\
	$(LIBPATH)/bitscanf.o\
	$(LIBPATH)/bitscanr.o\
	$(LIBPATH)/bitwrite.o\
	$(LIBPATH)/bitxchg.o\
	$(LIBPATH)/bitxor.o\
	$(LIBPATH)/bvector_new.o\
	$(LIBPATH)/bvectord.o\
	$(LIBPATH)/cabs.o\
	$(LIBPATH)/cagm.o\
	$(LIBPATH)/catan.o\
	$(LIBPATH)/ceil.o\
	$(LIBPATH)/chudnov.o\
	$(LIBPATH)/comparef.o\
	$(LIBPATH)/comparem.o\
	$(LIBPATH)/compfl.o\
	$(LIBPATH)/compful.o\
	$(LIBPATH)/compl.o\
	$(LIBPATH)/complex.o\
	$(LIBPATH)/compul.o\
	$(LIBPATH)/contfra1.o\
	$(LIBPATH)/contfra2.o\
	$(LIBPATH)/contfra3.o\
	$(LIBPATH)/contfra4.o\
	$(LIBPATH)/convld.o\
	$(LIBPATH)/cosc.o\
	$(LIBPATH)/cossinhc.o\
	$(LIBPATH)/cputime.o\
	$(LIBPATH)/cyc_num.o\
	$(LIBPATH)/dbgcmp.o\
	$(LIBPATH)/dbl.o\
	$(LIBPATH)/divcc.o\
	$(LIBPATH)/dividel.o\
	$(LIBPATH)/dividem.o\
	$(LIBPATH)/divideul.o\
	$(LIBPATH)/divf.o\
	$(LIBPATH)/divfc.o\
	$(LIBPATH)/divm.o\
	$(LIBPATH)/divpl.o\
	$(LIBPATH)/divul.o\
	$(LIBPATH)/ecm.o\
	$(LIBPATH)/egcdl.o\
	$(LIBPATH)/eta.o\
	$(LIBPATH)/euler.o\
	$(LIBPATH)/eulerphi.o\
	$(LIBPATH)/exp.o\
	$(LIBPATH)/expc.o\
	$(LIBPATH)/fact.o\
	$(LIBPATH)/fagm.o\
	$(LIBPATH)/fftinit.o\
	$(LIBPATH)/fftmul.o\
	$(LIBPATH)/fft.o\
	$(LIBPATH)/fib.o\
	$(LIBPATH)/fin.o\
	$(LIBPATH)/fint.o\
	$(LIBPATH)/fintc.o\
	$(LIBPATH)/fintdata.o\
	$(LIBPATH)/fcubrt.o\
	$(LIBPATH)/floor.o\
	$(LIBPATH)/fout.o\
	$(LIBPATH)/fpower.o\
	$(LIBPATH)/fp.o\
	$(LIBPATH)/frandom.o\
	$(LIBPATH)/gamma.o\
	$(LIBPATH)/gammaln.o\
	$(LIBPATH)/gausseli.o\
	$(LIBPATH)/gcdl.o\
	$(LIBPATH)/gcdm.o\
	$(LIBPATH)/gcdul.o\
	$(LIBPATH)/gelim.o\
	$(LIBPATH)/icubrt.o\
	$(LIBPATH)/ilog2l.o \
	$(LIBPATH)/ilog2m.o\
	$(LIBPATH)/intf.o\
	$(LIBPATH)/inverse.o\
	$(LIBPATH)/invmodpm.o\
	$(LIBPATH)/invmodpl.o\
	$(LIBPATH)/invmodul.o\
	$(LIBPATH)/invmodul.o\
	$(LIBPATH)/iobinary.o\
	$(LIBPATH)/irandom.o\
	$(LIBPATH)/irandomdat.o\
	$(LIBPATH)/irandomm.o\
	$(LIBPATH)/ipower.o\
	$(LIBPATH)/isqrt.o\
	$(LIBPATH)/isqrtul.o\
	$(LIBPATH)/isrem2.o\
	$(LIBPATH)/ksmbl.o\
	$(LIBPATH)/ksmblul.o\
	$(LIBPATH)/lanczos.o\
	$(LIBPATH)/lbit.o\
	$(LIBPATH)/len10.o\
	$(LIBPATH)/log.o\
	$(LIBPATH)/logc.o\
	$(LIBPATH)/mbitout.o\
	$(LIBPATH)/mint.o\
	$(LIBPATH)/mintc.o\
	$(LIBPATH)/mintcopy.o\
	$(LIBPATH)/modlul.o\
	$(LIBPATH)/mont.o\
	$(LIBPATH)/montdata.o\
	$(LIBPATH)/montred.o\
	$(LIBPATH)/mout.o\
	$(LIBPATH)/min.o\
	$(LIBPATH)/mintdata.o\
	$(LIBPATH)/mulc.o\
	$(LIBPATH)/mulf.o\
	$(LIBPATH)/mulm.o\
	$(LIBPATH)/mulmodul.o \
	$(LIBPATH)/mulul.o\
	$(LIBPATH)/nearint.o\
	$(LIBPATH)/nearintf.o\
	$(LIBPATH)/negate.o\
	$(LIBPATH)/nextprm.o\
	$(LIBPATH)/normc.o\
	$(LIBPATH)/nsinitre.o\
	$(LIBPATH)/nsinita.o\
	$(LIBPATH)/nsinitae.o\
	$(LIBPATH)/nsinitr.o\
	$(LIBPATH)/nsieve.o\
	$(LIBPATH)/orm.o\
	$(LIBPATH)/parse.o\
	$(LIBPATH)/pdecomp.o\
	$(LIBPATH)/perm.o\
	$(LIBPATH)/pollard.o\
	$(LIBPATH)/polylasm.o\
	$(LIBPATH)/polyfpasm.o\
	$(LIBPATH)/polyl.o\
	$(LIBPATH)/powdet.o\
	$(LIBPATH)/powerc.o\
	$(LIBPATH)/powmod.o\
	$(LIBPATH)/powmodul.o\
	$(LIBPATH)/powmodl.o\
	$(LIBPATH)/powpl.o\
	$(LIBPATH)/powfp.o\
	$(LIBPATH)/polyfp.o\
	$(LIBPATH)/polybase.o\
	$(LIBPATH)/prm.o\
	$(LIBPATH)/prmdiv.o\
	$(LIBPATH)/prmdivul.o\
	$(LIBPATH)/prmtbl.o\
	$(LIBPATH)/prmdiv2.o\
	$(LIBPATH)/prmorial.o\
	$(LIBPATH)/prmroot.o\
	$(LIBPATH)/prmrootp.o\
	$(LIBPATH)/qsortl2a.o\
	$(LIBPATH)/qsortla.o\
	$(LIBPATH)/qsortld.o\
	$(LIBPATH)/qsortul2a.o\
	$(LIBPATH)/qsortul4a.o\
	$(LIBPATH)/qsortula.o\
	$(LIBPATH)/qsortuld.o\
	$(LIBPATH)/qsortusa.o\
	$(LIBPATH)/qsortusd.o\
	$(LIBPATH)/qstack.o\
	$(LIBPATH)/rabin.o\
	$(LIBPATH)/rational.o\
	$(LIBPATH)/reallocm.o\
	$(LIBPATH)/reml.o\
	$(LIBPATH)/remm.o\
	$(LIBPATH)/remul.o\
	$(LIBPATH)/rho.o\
	$(LIBPATH)/rootmodp.o\
	$(LIBPATH)/roundf.o\
	$(LIBPATH)/sel_s_w.o\
	$(LIBPATH)/shift32.o\
	$(LIBPATH)/shiftl.o\
	$(LIBPATH)/shiftr.o\
	$(LIBPATH)/sigma.o\
	$(LIBPATH)/sigmaul.o\
	$(LIBPATH)/sigma_r.o\
	$(LIBPATH)/sinc.o\
	$(LIBPATH)/sincos.o\
	$(LIBPATH)/sinhcosh.o\
	$(LIBPATH)/smallprm.o\
	$(LIBPATH)/smatrix.o\
	$(LIBPATH)/sqcheck.o\
	$(LIBPATH)/sqrt.o\
	$(LIBPATH)/sqrtc.o\
	$(LIBPATH)/sqrtf.o\
	$(LIBPATH)/sqrtmodl.o\
	$(LIBPATH)/sqrtmodul.o\
	$(LIBPATH)/square.o\
	$(LIBPATH)/squaref.o\
	$(LIBPATH)/srchprm.o\
	$(LIBPATH)/subm.o\
	$(LIBPATH)/subul.o\
	$(LIBPATH)/swapm.o\
	$(LIBPATH)/tan.o\
	$(LIBPATH)/tbit.o\
	$(LIBPATH)/theta.o\
	$(LIBPATH)/xorm.o

#		*Explicit Rules*
mintlib: $(OBJS)
	ar rcs $(LIBPATH)/libmint.a $(OBJS)

#		*Individual File Dependencies*
$(LIBPATH)/addm.o:$(SRCPATH)/addm.asm
	$(NASM)	 $(AFLAGS) $(SRCPATH)/addm.asm

$(LIBPATH)/addsubul.o:$(SRCPATH)/addsubul.asm
	$(NASM) $(AFLAGS)  $(SRCPATH)/addsubul.asm

$(LIBPATH)/addul.o:$(SRCPATH)/addul.asm
	$(NASM) $(AFLAGS)  $(SRCPATH)/addul.asm

$(LIBPATH)/agcd.o:$(SRCPATH)/agcd.cpp
	$(CC) $(CFLAGS) $(SRCPATH)/agcd.cpp

$(LIBPATH)/allocf.o:$(SRCPATH)/allocf.cpp
	$(CC) $(CFLAGS) $(SRCPATH)/allocf.cpp

$(LIBPATH)/amodl.o:$(SRCPATH)/amodl.asm
	$(NASM)	 $(AFLAGS)	$(SRCPATH)/amodl.asm

$(LIBPATH)/amodul.o:$(SRCPATH)/amodul.asm
	$(NASM)	 $(AFLAGS)	$(SRCPATH)/amodul.asm

$(LIBPATH)/apowmod.o:$(SRCPATH)/apowmod.cpp
	$(CC) $(CFLAGS) $(SRCPATH)/apowmod.cpp

$(LIBPATH)/aprcl.o:$(SRCPATH)/aprcl.cpp
	$(CC) $(CFLAGS) $(SRCPATH)/aprcl.cpp

$(LIBPATH)/assignf.o:$(SRCPATH)/assignf.asm
	$(NASM) $(AFLAGS) $(SRCPATH)/assignf.asm

$(LIBPATH)/assignfl.o:$(SRCPATH)/assignfl.asm
	$(NASM) $(AFLAGS) $(SRCPATH)/assignfl.asm 

$(LIBPATH)/assignfd.o:$(SRCPATH)/assignfd.asm
	$(NASM) $(AFLAGS) $(SRCPATH)/assignfd.asm

$(LIBPATH)/assignl.o:	$(SRCPATH)/assignl.asm
	$(NASM) $(AFLAGS)  $(SRCPATH)/assignl.asm

$(LIBPATH)/assignmc.o:$(SRCPATH)/assignmc.cpp
	$(CC) $(CFLAGS) $(SRCPATH)/assignmc.cpp

$(LIBPATH)/assignul.o:	 $(SRCPATH)/assignul.asm
	$(NASM) $(AFLAGS)  $(SRCPATH)/assignul.asm

$(LIBPATH)/asrtfail.o: $(SRCPATH)/asrtfail.cpp
	$(CC) $(CFLAGS) $(SRCPATH)/asrtfail.cpp

$(LIBPATH)/assignm.o:$(SRCPATH)/assignm.asm
	$(NASM) $(AFLAGS) $(SRCPATH)/assignm.asm

$(LIBPATH)/bitand.o:$(SRCPATH)/bitand.asm
	$(NASM) $(AFLAGS) $(SRCPATH)/bitand.asm

$(LIBPATH)/atan.o:$(SRCPATH)/atan.cpp
	$(CC) $(CFLAGS) $(SRCPATH)/atan.cpp

$(LIBPATH)/bitindex.o:$(SRCPATH)/bitindex.asm
	$(NASM) $(AFLAGS) $(SRCPATH)/bitindex.asm

$(LIBPATH)/bitoff.o:$(SRCPATH)/bitoff.asm
	$(NASM) $(AFLAGS) $(SRCPATH)/bitoff.asm

$(LIBPATH)/biton.o:$(SRCPATH)/biton.asm
	$(NASM) $(AFLAGS) $(SRCPATH)/biton.asm

$(LIBPATH)/bitor.o:$(SRCPATH)/bitor.asm
	$(NASM) $(AFLAGS) $(SRCPATH)/bitor.asm

$(LIBPATH)/bitout.o:$(SRCPATH)/bitout.cpp
	$(CC) $(CFLAGS) $(SRCPATH)/bitout.cpp

$(LIBPATH)/bitread.o:$(SRCPATH)/bitread.cpp
	$(CC) $(CFLAGS) $(SRCPATH)/bitread.cpp

$(LIBPATH)/bitrvrs.o:$(SRCPATH)/bitrvrs.asm
	$(NASM) $(AFLAGS) $(SRCPATH)/bitrvrs.asm

$(LIBPATH)/bitscanf.o:$(SRCPATH)/bitscanf.asm
	$(NASM) $(AFLAGS) $(SRCPATH)/bitscanf.asm

$(LIBPATH)/bitscanr.o:$(SRCPATH)/bitscanr.asm
	$(NASM) $(AFLAGS) $(SRCPATH)/bitscanr.asm

$(LIBPATH)/bitwrite.o:$(SRCPATH)/bitwrite.cpp
	$(CC) $(CFLAGS) $(SRCPATH)/bitwrite.cpp

$(LIBPATH)/bitxchg.o:$(SRCPATH)/bitxchg.asm
	$(NASM) $(AFLAGS) $(SRCPATH)/bitxchg.asm

$(LIBPATH)/bitxor.o:$(SRCPATH)/bitxor.asm
	$(NASM) $(AFLAGS) $(SRCPATH)/bitxor.asm

$(LIBPATH)/bvector_new.o:$(SRCPATH)/bvector_new.asm
	$(NASM) $(AFLAGS) $(SRCPATH)/bvector_new.asm

$(LIBPATH)/bvectord.o:$(SRCPATH)/bvectord.cpp
	$(CC) $(CFLAGS) $(SRCPATH)/bvectord.cpp

$(LIBPATH)/cabs.o:$(SRCPATH)/cabs.cpp
	$(CC) $(CFLAGS) $(SRCPATH)/cabs.cpp

$(LIBPATH)/cagm.o:$(SRCPATH)/cagm.cpp
	$(CC) $(CFLAGS) $(SRCPATH)/cagm.cpp

$(LIBPATH)/catan.o:$(SRCPATH)/catan.cpp
	$(CC) $(CFLAGS) $(SRCPATH)/catan.cpp

$(LIBPATH)/ceil.o:$(SRCPATH)/ceil.cpp
	$(CC) $(CFLAGS) $(SRCPATH)/ceil.cpp

$(LIBPATH)/chudnov.o:	$(SRCPATH)/chudnov.cpp
	$(CC) $(CFLAGS)	 $(SRCPATH)/chudnov.cpp

$(LIBPATH)/compfl.o: $(SRCPATH)/compfl.asm
	$(NASM) $(AFLAGS)  $(SRCPATH)/compfl.asm

$(LIBPATH)/compful.o: $(SRCPATH)/compful.asm
	$(NASM) $(AFLAGS)  $(SRCPATH)/compful.asm

$(LIBPATH)/comparef.o:	 $(SRCPATH)/comparef.asm
	$(NASM) $(AFLAGS)  $(SRCPATH)/comparef.asm

$(LIBPATH)/comparem.o:	 $(SRCPATH)/comparem.asm
	$(NASM) $(AFLAGS)  $(SRCPATH)/comparem.asm

$(LIBPATH)/compl.o:	  $(SRCPATH)/compl.asm
	$(NASM) $(AFLAGS)  $(SRCPATH)/compl.asm

$(LIBPATH)/complex.o:$(SRCPATH)/complex.cpp
	$(CC) $(CFLAGS) $(SRCPATH)/complex.cpp

$(LIBPATH)/compul.o:$(SRCPATH)/compul.asm
	$(NASM) $(AFLAGS) $(SRCPATH)/compul.asm


$(LIBPATH)/contfra1.o:$(SRCPATH)/contfra1.cpp
	$(CC) $(CFLAGS) $(SRCPATH)/contfra1.cpp

$(LIBPATH)/contfra2.o:$(SRCPATH)/contfra2.cpp
	$(CC) $(CFLAGS) $(SRCPATH)/contfra2.cpp

$(LIBPATH)/contfra3.o:$(SRCPATH)/contfra3.cpp
	$(CC) $(CFLAGS) $(SRCPATH)/contfra3.cpp

$(LIBPATH)/contfra4.o:$(SRCPATH)/contfra4.cpp
	$(CC) $(CFLAGS) $(SRCPATH)/contfra4.cpp

$(LIBPATH)/convld.o: $(SRCPATH)/convld.cpp
	$(CC) $(CFLAGS) $(SRCPATH)/convld.cpp

$(LIBPATH)/cosc.o:$(SRCPATH)/cosc.cpp
	$(CC) $(CFLAGS) $(SRCPATH)/cosc.cpp

$(LIBPATH)/cossinhc.o:$(SRCPATH)/cossinhc.cpp
	$(CC) $(CFLAGS) $(SRCPATH)/cossinhc.cpp

$(LIBPATH)/cputime.o: $(SRCPATH)/cputime.cpp
	$(CC) $(CFLAGS) $(SRCPATH)/cputime.cpp

$(LIBPATH)/cyc_num.o:$(SRCPATH)/cyc_num.cpp
	$(CC) $(CFLAGS) $(SRCPATH)/cyc_num.cpp

$(LIBPATH)/dbgcmp.o:$(SRCPATH)/dbgcmp.cpp
	$(CC) $(CFLAGS) $(SRCPATH)/dbgcmp.cpp


$(LIBPATH)/dbl.o:	$(SRCPATH)/dbl.asm
	$(NASM) $(AFLAGS)  $(SRCPATH)/dbl.asm

$(LIBPATH)/divcc.o:$(SRCPATH)/divcc.cpp
	$(CC) $(CFLAGS) $(SRCPATH)/divcc.cpp

$(LIBPATH)/dividel.o:$(SRCPATH)/dividel.asm
	$(NASM) $(AFLAGS) $(SRCPATH)/dividel.asm

$(LIBPATH)/dividem.o : $(SRCPATH)/dividem.asm
	$(NASM)	 $(AFLAGS)	$(SRCPATH)/dividem.asm

$(LIBPATH)/divideul.o:$(SRCPATH)/divideul.asm
	$(NASM) $(AFLAGS) $(SRCPATH)/divideul.asm 

$(LIBPATH)/divf.o:$(SRCPATH)/divf.asm
	$(NASM) $(AFLAGS) $(SRCPATH)/divf.asm

$(LIBPATH)/divfc.o:$(SRCPATH)/divfc.cpp
	$(CC) $(CFLAGS) $(SRCPATH)/divfc.cpp

$(LIBPATH)/divm.o:$(SRCPATH)/divm.asm
	$(NASM) $(AFLAGS) $(SRCPATH)/divm.asm

$(LIBPATH)/divpl.o:$(SRCPATH)/divpl.cpp
	$(CC) $(CFLAGS) $(SRCPATH)/divpl.cpp

$(LIBPATH)/divul.o:$(SRCPATH)/divul.asm
	$(NASM) $(AFLAGS) $(SRCPATH)/divul.asm

$(LIBPATH)/ecm.o:$(SRCPATH)/ecm.cpp
	$(CC) $(CFLAGS) $(SRCPATH)/ecm.cpp

$(LIBPATH)/egcdl.o:$(SRCPATH)/egcdl.asm
	$(NASM) $(AFLAGS) $(SRCPATH)/egcdl.asm

$(LIBPATH)/eta.o:$(SRCPATH)/eta.cpp
	$(CC) $(CFLAGS) $(SRCPATH)/eta.cpp

$(LIBPATH)/euler.o:$(SRCPATH)/euler.cpp
	$(CC) $(CFLAGS) $(SRCPATH)/euler.cpp

$(LIBPATH)/eulerphi.o:$(SRCPATH)/eulerphi.asm
	$(NASM) $(AFLAGS) $(SRCPATH)/eulerphi.asm

$(LIBPATH)/exp.o: $(SRCPATH)/exp.cpp
	$(CC) $(CFLAGS) $(SRCPATH)/exp.cpp

$(LIBPATH)/expc.o:$(SRCPATH)/expc.cpp
	$(CC) $(CFLAGS) $(SRCPATH)/expc.cpp

$(LIBPATH)/fact.o: $(SRCPATH)/fact.cpp
	$(CC) $(CFLAGS) $(SRCPATH)/fact.cpp

$(LIBPATH)/fagm.o:$(SRCPATH)/fagm.cpp
	$(CC) $(CFLAGS) $(SRCPATH)/fagm.cpp

$(LIBPATH)/fcubrt.o: $(SRCPATH)/fcubrt.cpp
	$(CC) $(CFLAGS) $(SRCPATH)/fcubrt.cpp

$(LIBPATH)/fft.o: $(SRCPATH)/fft.asm
	$(NASM)	 $(AFLAGS) $(SRCPATH)/fft.asm

$(LIBPATH)/fftinit.o:$(SRCPATH)/fftinit.asm
	$(NASM)	 $(AFLAGS) $(SRCPATH)/fftinit.asm

$(LIBPATH)/fftmul.o: $(SRCPATH)/fftmul.asm
	$(NASM)	 $(AFLAGS) $(SRCPATH)/fftmul.asm

$(LIBPATH)/fib.o:$(SRCPATH)/fib.cpp
	$(CC) $(CFLAGS) $(SRCPATH)/fib.cpp

$(LIBPATH)/fin.o:$(SRCPATH)/fin.cpp
	$(CC) $(CFLAGS) $(SRCPATH)/fin.cpp

$(LIBPATH)/fint.o:$(SRCPATH)/fint.cpp
	$(CC) $(CFLAGS) $(SRCPATH)/fint.cpp

$(LIBPATH)/fintc.o:$(SRCPATH)/fintc.cpp
	$(CC) $(CFLAGS) $(SRCPATH)/fintc.cpp

$(LIBPATH)/fintdata.o:$(SRCPATH)/fintdata.cpp
	$(CC) $(CFLAGS) $(SRCPATH)/fintdata.cpp

$(LIBPATH)/floor.o: $(SRCPATH)/floor.cpp
	$(CC) $(CFLAGS) $(SRCPATH)/floor.cpp

$(LIBPATH)/fout.o: $(SRCPATH)/fout.cpp
	$(CC) $(CFLAGS) $(SRCPATH)/fout.cpp

$(LIBPATH)/fp.o: $(SRCPATH)/fp.cpp
	$(CC) $(CFLAGS) $(SRCPATH)/fp.cpp

$(LIBPATH)/fpower.o: $(SRCPATH)/fpower.cpp
	$(CC) $(CFLAGS) $(SRCPATH)/fpower.cpp

$(LIBPATH)/frandom.o:$(SRCPATH)/frandom.asm
	$(NASM) $(AFLAGS) $(SRCPATH)/frandom.asm

$(LIBPATH)/gamma.o:$(SRCPATH)/gamma.cpp
	$(CC) $(CFLAGS) $(SRCPATH)/gamma.cpp

$(LIBPATH)/gammaln.o:$(SRCPATH)/gammaln.cpp
	$(CC) $(CFLAGS) $(SRCPATH)/gammaln.cpp

$(LIBPATH)/gausseli.o:$(SRCPATH)/gausseli.asm
	$(NASM) $(AFLAGS) $(SRCPATH)/gausseli.asm

$(LIBPATH)/gcdl.o:$(SRCPATH)/gcdl.asm
	$(NASM) $(AFLAGS) $(SRCPATH)/gcdl.asm


$(LIBPATH)/gcdm.o: $(SRCPATH)/gcdm.cpp
	$(CC) $(CFLAGS) $(SRCPATH)/gcdm.cpp

$(LIBPATH)/gcdul.o:	  $(SRCPATH)/gcdul.asm
	$(NASM) $(AFLAGS) $(SRCPATH)/gcdul.asm

$(LIBPATH)/gelim.o:	  $(SRCPATH)/gelim.asm
	$(NASM) $(AFLAGS) $(SRCPATH)/gelim.asm

$(LIBPATH)/icubrt.o: $(SRCPATH)/icubrt.cpp
	$(CC) $(CFLAGS) $(SRCPATH)/icubrt.cpp

$(LIBPATH)/ilog2l.o:  $(SRCPATH)/ilog2l.asm
	$(NASM)	 $(AFLAGS) $(SRCPATH)/ilog2l.asm

$(LIBPATH)/ilog2m.o: $(SRCPATH)/ilog2m.asm
	$(NASM)	 $(AFLAGS)	$(SRCPATH)/ilog2m.asm

$(LIBPATH)/intf.o:$(SRCPATH)/intf.asm
	$(NASM) $(AFLAGS) $(SRCPATH)/intf.asm

$(LIBPATH)/inverse.o:$(SRCPATH)/inverse.asm
	$(NASM) $(AFLAGS) $(SRCPATH)/inverse.asm

$(LIBPATH)/invmodpl.o: $(SRCPATH)/invmodpl.asm
	$(NASM)	 $(AFLAGS)	$(SRCPATH)/invmodpl.asm

$(LIBPATH)/invmodpm.o: $(SRCPATH)/invmodpm.asm
	$(NASM)	 $(AFLAGS)	$(SRCPATH)/invmodpm.asm

$(LIBPATH)/invmodul.o: $(SRCPATH)/invmodul.asm
	$(NASM)	 $(AFLAGS)	$(SRCPATH)/invmodul.asm

$(LIBPATH)/iobinary.o:$(SRCPATH)/iobinary.cpp
	$(CC) $(CFLAGS) $(SRCPATH)/iobinary.cpp

$(LIBPATH)/ipower.o: $(SRCPATH)/ipower.cpp
	$(CC) $(CFLAGS)	 $(SRCPATH)/ipower.cpp

$(LIBPATH)/irandom.o: $(SRCPATH)/irandom.asm
	$(NASM)	 $(AFLAGS) $(SRCPATH)/irandom.asm

$(LIBPATH)/irandomdat.o:$(SRCPATH)/irandomdat.cpp
	$(CC) $(CFLAGS) $(SRCPATH)/irandomdat.cpp

$(LIBPATH)/irandomm.o:$(SRCPATH)/irandomm.cpp
	$(CC) $(CFLAGS) $(SRCPATH)/irandomm.cpp

$(LIBPATH)/isqrt.o: $(SRCPATH)/isqrt.cpp
	$(CC) $(CFLAGS) $(SRCPATH)/isqrt.cpp

$(LIBPATH)/isqrtul.o: $(SRCPATH)/isqrtul.asm
	$(NASM)	 $(AFLAGS)	$(SRCPATH)/isqrtul.asm

$(LIBPATH)/isrem2.o:$(SRCPATH)/isrem2.asm  
	$(NASM) $(AFLAGS) $(SRCPATH)/isrem2.asm

$(LIBPATH)/ksmbl.o:$(SRCPATH)/ksmbl.cpp
	$(CC) $(CFLAGS) $(SRCPATH)/ksmbl.cpp

$(LIBPATH)/ksmblul.o: $(SRCPATH)/ksmblul.asm
	$(NASM)	 $(AFLAGS)	$(SRCPATH)/ksmblul.asm

$(LIBPATH)/lanczos.o:$(SRCPATH)/lanczos.cpp
	$(CC) $(CFLAGS) $(SRCPATH)/lanczos.cpp
	
$(LIBPATH)/lbit.o:$(SRCPATH)/lbit.cpp
	$(CC) $(CFLAGS) $(SRCPATH)/lbit.cpp

$(LIBPATH)/lcm.o:$(SRVPATH)/lcm.cpp	
	$(CC) $(CFLAGS) $(SRCPATH)/lcm.cpp

$(LIBPATH)/len10.o:$(SRCPATH)/len10.cpp
	$(CC) $(CFLAGS) $(SRCPATH)/len10.cpp

$(LIBPATH)/log.o:$(SRCPATH)/log.cpp
	$(CC) $(CFLAGS) $(SRCPATH)/log.cpp

$(LIBPATH)/logc.o:$(SRCPATH)/logc.cpp
	$(CC) $(CFLAGS) $(SRCPATH)/logc.cpp

$(LIBPATH)/mbitout.o:$(SRCPATH)/mbitout.cpp
	$(CC) $(CFLAGS) $(SRCPATH)/mbitout.cpp

$(LIBPATH)/min.o: $(SRCPATH)/min.cpp
	$(CC) $(CFLAGS) $(SRCPATH)/min.cpp

$(LIBPATH)/mint.o: $(SRCPATH)/mint.cpp
	$(CC) $(CFLAGS) $(SRCPATH)/mint.cpp

$(LIBPATH)/mintc.o:$(SRCPATH)/mintc.cpp
	$(CC) $(CFLAGS) $(SRCPATH)/mintc.cpp

$(LIBPATH)/mintcopy.o:	 $(SRCPATH)/mintcopy.asm
	$(NASM) $(AFLAGS) $(SRCPATH)/mintcopy.asm

$(LIBPATH)/mintdata.o: $(SRCPATH)/mintdata.cpp
	$(CC) $(CFLAGS) $(SRCPATH)/mintdata.cpp

$(LIBPATH)/modl.o:	 $(SRCPATH)/modl.asm
	$(NASM) $(AFLAGS) $(SRCPATH)/modl.asm

$(LIBPATH)/modlul.o:   $(SRCPATH)/modlul.asm
	$(NASM) $(AFLAGS) $(SRCPATH)/modlul.asm

$(LIBPATH)/mulc.o:$(SRCPATH)/mulc.cpp
	$(CC) $(CFLAGS) $(SRCPATH)/mulc.cpp

$(LIBPATH)/mulm.o:	 $(SRCPATH)/mulm.asm
	$(NASM) $(AFLAGS) $(SRCPATH)/mulm.asm

$(LIBPATH)/mont.o:$(SRCPATH)/mont.cpp
	$(CC) $(CFLAGS) $(SRCPATH)/mont.cpp

$(LIBPATH)/montdata.o:$(SRCPATH)/montdata.cpp
	$(CC) $(CFLAGS) $(SRCPATH)/montdata.cpp

$(LIBPATH)/montred.o:$(SRCPATH)/montred.asm
	$(NASM) $(AFLAGS) $(SRCPATH)/montred.asm

$(LIBPATH)/mout.o: $(SRCPATH)/mout.cpp
	$(CC) $(CFLAGS) $(SRCPATH)/mout.cpp

$(LIBPATH)/mulf.o:$(SRCPATH)/mulf.asm
	$(NASM) $(AFLAGS) $(SRCPATH)/mulf.asm

$(LIBPATH)/mulmodul.o: $(SRCPATH)/mulmodul.asm
	$(NASM)	 $(AFLAGS) $(SRCPATH)/mulmodul.asm

$(LIBPATH)/mulul.o: $(SRCPATH)/mulul.asm
	$(NASM)	 $(AFLAGS)	$(SRCPATH)/mulul.asm

$(LIBPATH)/nearint.o: $(SRCPATH)/nearint.cpp
	$(CC) $(CFLAGS) $(SRCPATH)/nearint.cpp

$(LIBPATH)/nearintf.o: $(SRCPATH)/nearintf.cpp
	$(CC) $(CFLAGS) $(SRCPATH)/nearintf.cpp

$(LIBPATH)/negate.o:   $(SRCPATH)/negate.asm
	$(NASM) $(AFLAGS) $(SRCPATH)/negate.asm

$(LIBPATH)/nextprm.o:	$(SRCPATH)/nextprm.asm
	$(NASM) $(AFLAGS) $(SRCPATH)/nextprm.asm

$(LIBPATH)/normc.o:$(SRCPATH)/normc.cpp
	$(CC) $(CFLAGS) $(SRCPATH)/normc.cpp

$(LIBPATH)/nsieve.o:   $(SRCPATH)/nsieve.asm
	$(NASM) $(AFLAGS) $(SRCPATH)/nsieve.asm

$(LIBPATH)/nsinitre.o: $(SRCPATH)/nsinitre.asm
	$(NASM)	 $(AFLAGS) $(SRCPATH)/nsinitre.asm

$(LIBPATH)/nsinitr.o: $(SRCPATH)/nsinitr.asm
	$(NASM)	 $(AFLAGS) $(SRCPATH)/nsinitr.asm

$(LIBPATH)/nsinitae.o: $(SRCPATH)/nsinitae.asm
	$(NASM)	 $(AFLAGS) $(SRCPATH)/nsinitae.asm

$(LIBPATH)/nsinita.o: $(SRCPATH)/nsinita.asm
	$(NASM)	 $(AFLAGS) $(SRCPATH)/nsinita.asm

$(LIBPATH)/orm.o:$(SRCPATH)/orm.asm
	$(NASM) $(AFLAGS) $(SRCPATH)/orm.asm

$(LIBPATH)/parse.o: $(SRCPATH)/parse.cpp
	$(CC) $(CFLAGS) $(SRCPATH)/parse.cpp

$(LIBPATH)/pdecomp.o: $(SRCPATH)/pdecomp.asm
	$(NASM)	 $(AFLAGS) $(SRCPATH)/pdecomp.asm

$(LIBPATH)/perm.o:$(SRCPATH)/perm.cpp
	$(CC) $(CFLAGS) $(SRCPATH)/perm.cpp

$(LIBPATH)/pollard.o:$(SRCPATH)/pollard.cpp
	$(CC) $(CFLAGS) $(SRCPATH)/pollard.cpp

$(LIBPATH)/polyl.o: $(SRCPATH)/polyl.cpp
	$(CC) $(CFLAGS) $(SRCPATH)/polyl.cpp

$(LIBPATH)/polyfp.o: $(SRCPATH)/polyfp.cpp
	$(CC) $(CFLAGS) $(SRCPATH)/polyfp.cpp

$(LIBPATH)/polybase.o: $(SRCPATH)/polybase.cpp
	$(CC) $(CFLAGS) $(SRCPATH)/polybase.cpp

$(LIBPATH)/polyfpasm.o:	  $(SRCPATH)/polyfpasm.asm
	$(NASM) $(AFLAGS) $(SRCPATH)/polyfpasm.asm

$(LIBPATH)/polylasm.o:	 $(SRCPATH)/polylasm.asm
	$(NASM) $(AFLAGS) $(SRCPATH)/polylasm.asm

$(LIBPATH)/powdet.o: $(SRCPATH)/powdet.cpp
	$(CC) $(CFLAGS) $(SRCPATH)/powdet.cpp

$(LIBPATH)/powerc.o:$(SRCPATH)/powerc.cpp
	$(CC) $(CFLAGS) $(SRCPATH)/powerc.cpp

$(LIBPATH)/powpl.o: $(SRCPATH)/powpl.cpp
	$(CC) $(CFLAGS) $(SRCPATH)/powpl.cpp

$(LIBPATH)/powfp.o: $(SRCPATH)/powfp.cpp
	$(CC) $(CFLAGS) $(SRCPATH)/powfp.cpp

$(LIBPATH)/powmod.o:$(SRCPATH)/powmod.cpp
	$(CC) $(CFLAGS)	 $(SRCPATH)/powmod.cpp

$(LIBPATH)/powmodl.o:$(SRCPATH)/powmodl.asm
	$(NASM)	 $(AFLAGS)	$(SRCPATH)/powmodl.asm

$(LIBPATH)/powmodul.o:$(SRCPATH)/powmodul.asm
	$(NASM)	 $(AFLAGS)	$(SRCPATH)/powmodul.asm

$(LIBPATH)/prm.o:$(SRCPATH)/prm.asm
	$(NASM) $(AFLAGS) $(SRCPATH)/prm.asm

$(LIBPATH)/prmdiv.o:$(SRCPATH)/prmdiv.asm
	$(NASM) $(AFLAGS) $(SRCPATH)/prmdiv.asm

$(LIBPATH)/prmdiv2.o:	$(SRCPATH)/prmdiv2.asm
	$(NASM) $(AFLAGS) $(SRCPATH)/prmdiv2.asm


$(LIBPATH)/prmdivul.o:	 $(SRCPATH)/prmdivul.asm
	$(NASM) $(AFLAGS) $(SRCPATH)/prmdivul.asm

$(LIBPATH)/prmorial.o:$(SRCPATH)/prmorial.cpp
	$(CC) $(CFLAGS) $(SRCPATH)/prmorial.cpp

$(LIBPATH)/prmroot.o:$(SRCPATH)/prmroot.asm
	$(NASM) $(AFLAGS) $(SRCPATH)/prmroot.asm

$(LIBPATH)/prmrootp.o:$(SRCPATH)/prmrootp.asm
	$(NASM) $(AFLAGS) $(SRCPATH)/prmrootp.asm 

$(LIBPATH)/prmtbl.o:$(SRCPATH)/prmtbl.cpp
	$(CC) $(CFLAGS) $(SRCPATH)/prmtbl.cpp

$(LIBPATH)/qsortl2a.o:$(SRCPATH)/qsortl2a.asm
	$(NASM) $(AFLAGS) $(SRCPATH)/qsortl2a.asm

$(LIBPATH)/qsortla.o:$(SRCPATH)/qsortla.asm
	$(NASM) $(AFLAGS) $(SRCPATH)/qsortla.asm 

$(LIBPATH)/qsortld.o:$(SRCPATH)/qsortld.asm
	$(NASM) $(AFLAGS) $(SRCPATH)/qsortld.asm 

$(LIBPATH)/qsortul2a.o:$(SRCPATH)/qsortul2a.asm
	$(NASM) $(AFLAGS) $(SRCPATH)/qsortul2a.asm

$(LIBPATH)/qsortul4a.o:$(SRCPATH)/qsortul4a.asm
	$(NASM) $(AFLAGS) $(SRCPATH)/qsortul4a.asm

$(LIBPATH)/qsortula.o:$(SRCPATH)/qsortula.asm
	$(NASM) $(AFLAGS) $(SRCPATH)/qsortula.asm

$(LIBPATH)/qsortuld.o:$(SRCPATH)/qsortuld.asm
	$(NASM) $(AFLAGS) $(SRCPATH)/qsortuld.asm

$(LIBPATH)/qsortusa.o:$(SRCPATH)/qsortusa.asm
	$(NASM) $(AFLAGS) $(SRCPATH)/qsortusa.asm

$(LIBPATH)/qsortusd.o:$(SRCPATH)/qsortusd.asm
	$(NASM) $(AFLAGS) $(SRCPATH)/qsortusd.asm

$(LIBPATH)/qstack.o:$(SRCPATH)/qstack.cpp
	$(CC) $(CFLAGS) $(SRCPATH)/qstack.cpp

$(LIBPATH)/rabin.o:$(SRCPATH)/rabin.cpp
	$(CC) $(CFLAGS) $(SRCPATH)/rabin.cpp

$(LIBPATH)/rational.o:$(SRCPATH)/rational.cpp
	$(CC) $(CFLAGS) $(SRCPATH)/rational.cpp

$(LIBPATH)/reallocm.o: $(SRCPATH)/reallocm.asm
	$(NASM)	 $(AFLAGS) $(SRCPATH)/reallocm.asm

$(LIBPATH)/reml.o:$(SRCPATH)/reml.asm
	$(NASM) $(AFLAGS) $(SRCPATH)/reml.asm

$(LIBPATH)/remm.o:$(SRCPATH)/remm.asm
	$(NASM) $(AFLAGS) $(SRCPATH)/remm.asm

$(LIBPATH)/rho.o:$(SRCPATH)/rho.cpp
	$(CC) $(CFLAGS) $(SRCPATH)/rho.cpp

$(LIBPATH)/remul.o:$(SRCPATH)/remul.asm
	$(NASM) $(AFLAGS) $(SRCPATH)/remul.asm

$(LIBPATH)/rootmodp.o: $(SRCPATH)/rootmodp.cpp
	$(CC) $(CFLAGS) $(SRCPATH)/rootmodp.cpp

$(LIBPATH)/roundf.o:$(SRCPATH)/roundf.asm
	$(NASM) $(AFLAGS) $(SRCPATH)/roundf.asm

$(LIBPATH)/sel_s_w.o:$(SRCPATH)/sel_s_w.asm
	$(NASM) $(AFLAGS) $(SRCPATH)/sel_s_w.asm

$(LIBPATH)/shift32.o:	$(SRCPATH)/shift32.asm
	$(NASM) $(AFLAGS) $(SRCPATH)/shift32.asm

$(LIBPATH)/shiftl.o:   $(SRCPATH)/shiftl.asm
	$(NASM) $(AFLAGS) $(SRCPATH)/shiftl.asm

$(LIBPATH)/shiftr.o:   $(SRCPATH)/shiftr.asm
	$(NASM) $(AFLAGS) $(SRCPATH)/shiftr.asm

$(LIBPATH)/sigma.o:$(SRCPATH)/sigma.cpp
	$(CC) $(CFLAGS) $(SRCPATH)/sigma.cpp

$(LIBPATH)/sigma_r.o:$(SRCPATH)/sigma_r.cpp
	$(CC) $(CFLAGS) $(SRCPATH)/sigma_r.cpp

$(LIBPATH)/sigmaul.o:$(SRCPATH)/sigmaul.cpp
	$(CC) $(CFLAGS) $(SRCPATH)/sigmaul.cpp

$(LIBPATH)/sinc.o:$(SRCPATH)/sinc.cpp
	$(CC) $(CFLAGS) $(SRCPATH)/sinc.cpp

$(LIBPATH)/sincos.o:$(SRCPATH)/sincos.cpp
	$(CC) $(CFLAGS) $(SRCPATH)/sincos.cpp

$(LIBPATH)/sinhcosh.o:$(SRCPATH)/sinhcosh.cpp
	$(CC) $(CFLAGS) $(SRCPATH)/sinhcosh.cpp

$(LIBPATH)/smallprm.o:	 $(SRCPATH)/smallprm.cpp
	$(CC) $(CFLAGS) $(SRCPATH)/smallprm.cpp

$(LIBPATH)/smatrix.o:$(SRCPATH)/smatrix.cpp
	$(CC) $(CFLAGS) $(SRCPATH)/smatrix.cpp

$(LIBPATH)/sqcheck.o:$(SRCPATH)/sqcheck.cpp
	$(CC) $(CFLAGS) $(SRCPATH)/sqcheck.cpp

$(LIBPATH)/sqrt.o:$(SRCPATH)/sqrt.cpp
	$(CC) $(CFLAGS) $(SRCPATH)/sqrt.cpp

$(LIBPATH)/sqrtc.o:$(SRCPATH)/sqrtc.cpp
	$(CC) $(CFLAGS) $(SRCPATH)/sqrtc.cpp 

$(LIBPATH)/sqrtf.o:$(SRCPATH)/sqrtf.asm
	$(NASM) $(AFLAGS) $(SRCPATH)/sqrtf.asm

$(LIBPATH)/sqrtmodl.o:$(SRCPATH)/sqrtmodl.asm
	$(NASM) $(AFLAGS) $(SRCPATH)/sqrtmodl.asm

$(LIBPATH)/sqrtmodul.o: $(SRCPATH)/sqrtmodul.asm
	$(NASM)	 $(AFLAGS)	$(SRCPATH)/sqrtmodul.asm

$(LIBPATH)/square.o : $(SRCPATH)/square.asm
	$(NASM)	 $(AFLAGS) $(SRCPATH)/square.asm

$(LIBPATH)/squaref.o:$(SRCPATH)/squaref.asm
	$(NASM) $(AFLAGS) $(SRCPATH)/squaref.asm

$(LIBPATH)/srchprm.o:$(SRCPATH)/srchprm.asm
	$(NASM) $(AFLAGS) $(SRCPATH)/srchprm.asm

$(LIBPATH)/subm.o:$(SRCPATH)/subm.asm
	$(NASM) $(AFLAGS) $(SRCPATH)/subm.asm

$(LIBPATH)/subul.o:$(SRCPATH)/subul.asm
	$(NASM) $(AFLAGS) $(SRCPATH)/subul.asm

$(LIBPATH)/swapm.o: $(SRCPATH)/swapm.asm
	$(NASM)	 $(AFLAGS) $(SRCPATH)/swapm.asm

$(LIBPATH)/tan.o:$(SRCPATH)/tan.cpp
	$(CC) $(CFLAGS) $(SRCPATH)/tan.cpp

$(LIBPATH)/tbit.o:$(SRCPATH)/tbit.asm
	$(NASM) $(AFLAGS) $(SRCPATH)/tbit.asm

$(LIBPATH)/theta.o:$(SRCPATH)/theta.cpp
	$(CC) $(CFLAGS) $(SRCPATH)/theta.cpp

$(LIBPATH)/xorm.o:$(SRCPATH)/xorm.asm
	$(NASM) $(AFLAGS) $(SRCPATH)/xorm.asm
