//
//  Copyright (C) by S.Tomabechi 1995
//  All rights reserved.
//
//  calculate pi by arithmetic-geometric mean method
//

#include "Fint.hpp"

Fint agmpi(int precision)
{
  precision=SetPrecision(precision) ;
  Fint a,b,c,s,y ;
  long t ;

  a=1 ;
  b=1/sqrt(Fint(2)) ;
  t=0 ;
  s=1 ; s>>=2 ;
  while( (c=a-b).ndigit()>1 ) {  // convergent ?
    y=(a+b)>>1 ; //    y=(a+b)/2 ;
    c=a-y ;
    b=sqrt(a*b) ;
    a=y ;
    s-=((c*c)<<=t) ;
    t++ ;
  }
  SetPrecision(precision) ;
  return square(a+b)/(s<<=2) ;
//  return sqrt(a+b)/(s<<=2) ;
}
