#include <stdlib.h>
#include <iostream.h>
#include <time.h>
#include <memory.h>
#include "Mint.hpp"
#include "IntFuncs.hpp"
void QSortULA(const long,const long,const long,unsigned long*) ;
#include "Hash.hpp"


void Hash::resize(unsigned long _size)
{
  if( count ) delete [] count ;
  count=new unsigned char[_size] ;
  memset(count,0x00,_size*sizeof(unsigned char)) ;
  size=_size;
}

Hash::Hash(const unsigned long _m,const unsigned long _size):size(_size),m(_m),count(NULL)
{
  count=new unsigned char[_size] ;
  memset(count,0x00,_size*sizeof(unsigned char)) ;
}

void Hash::set(const unsigned long key)
{
  __asm {
	mov esi,this
	mov eax,key
	mul eax
	xor eax,edx
	shr eax,3
//	mul dword ptr [esi.m]
//	shr eax,1
//	shr eax,3
//    add   eax,1013904223

//	add eax,edx
//    xor eax,edx
	xor edx,edx

#ifdef __BORLANDC__
	div dword ptr [esi.size]
	mov esi,[esi.count]
#else
	div dword ptr [esi+_SIZE]
	mov esi,[esi+_COUNT]
#endif	
	mov al,[esi+edx]
	cmp al,0xff ;
	je  RET1
	inc al
	mov [esi+edx],al
  }
RET1:;
//  count[key]++ ;
}


void Hash::remove(const unsigned long key)
{
  __asm {
	mov esi,this
	mov eax,key
	mul eax
	xor eax,edx
	shr eax,3
//	mul dword ptr [esi.m]
//	shr eax,1
//	shr eax,3
//    add   eax,1013904223

//	add eax,edx
//    xor eax,edx
	xor edx,edx

#ifdef __BORLANDC__
	div dword ptr [esi.size]
	mov esi,[esi.count]
#else
	div dword ptr [esi+_SIZE]
	mov esi,[esi+_COUNT]
#endif	
	mov al,[esi+edx]
	cmp al,0x00 ;
	je  RET1
	dec al
	mov [esi+edx],al
  }
RET1:;
//  count[key]++ ;
}





unsigned long Hash::result(const unsigned long key)
{
  __asm {
	mov esi,this
	mov eax,key
	mul eax
	xor eax,edx
	shr eax,3
//	mul dword ptr [esi.m]
//	shr eax,1
//	shr eax,3
//    add   eax,1013904223
//	add eax,edx
//    xor eax,edx
	xor edx,edx
#ifdef __BORLANDC__
	div dword ptr [esi.size]
	mov esi,[esi.count]
#else
	div dword ptr [esi+_SIZE]
	mov esi,[esi+_COUNT]
#endif	
	movzx eax,byte ptr [esi+edx]
	mov   key,eax
  }

  return key ;
//  return count[key]	;
//  count[key]++ ;
}



unsigned long Hash::key(const unsigned long key)
{
  __asm {
	mov esi,this
	mov eax,key
	mul eax
	xor eax,edx
	shr eax,3
//	mul dword ptr [esi.m]
//	add eax,edx
	xor edx,edx
#ifdef __BORLANDC__	
	div dword ptr [esi.size]
#else
	div dword ptr [esi+_SIZE]
#endif	
	mov   key,edx
  }

  return key ;
//  return count[key]	;
//  count[key]++ ;
}







#if 0
int main(void)
{
  Hash h(104729,4096*2) ;
  unsigned long seed=time(NULL) ;
  unsigned long* n ;
  long nentry ;
  unsigned long j ;

  nentry=2*2*4096*2 ;
  n=new unsigned long[nentry] ;
  for( j=0 ; j<nentry ; j++ ) {
    n[j]=irandom(seed) & 0x00FFFFFF ;
//    n[j]%=65536 ;
    n[j]=nextprm(n[j]) ;
    h.set(n[j]) ;
  }

  QSortULA(nentry,4,0,n) ;
  for( j=0 ; j<nentry ; j++ ) {
//	if( h.result(n[j])<=1 )
	cout << endl << n[j] << " " << h.result(n[j]) << " "  ;
  }
  for( j=0 ; j<nentry ; j++ ) {
	if( h.result(n[j])<=1 )
	cout << endl << n[j] << " " << h.result(n[j]) << " "  ;
  }

  delete [] n ;
  return 0 ;
}

#endif
