//
//  Copyright (C) by S.Tomabechi 1993
//  All rights reserved.
//
//  Ȗ񎟌`̐ɂ,ސvZ
//
//  Algorithm 5.3.5 ( h(-D) Counting Reduced Forms )
//  Given a negative discriminant -D, this algoorithm outputs the classs number
//  of quadratic forms of discriminant -D, i.e. h(-D) when -D is a fundamental discriminant.
//
#include <stdlib.h>
#include <algorith.h>
#include <vector.h>
#include <math.h>
#include <stdio.h>
#include <iostream.h>
#include "CPUTime.hpp"
#include "IntFuncs.hpp"
#include "Error.hpp"
#include "Complex.hpp"
#include <complex.h>
#include "PolyM.hpp"
#include "PolyC.hpp"
#include "Mint.hpp"

using namespace std ;

int Root(const PolyC& p,vector<Complex>& zero);
int RootModp(PolyM& f,Mint& N,vector< Mint >& roots);
Complex delta(Complex& tau) ;
Complex eta1(Complex& tau) ;
unsigned long hD(unsigned long D,unsigned long D1=0) ;
Complex J(Complex& tau);
Complex Weber(const unsigned long D,const unsigned long a,const unsigned long b,const Complex& tau) ;
void WP(unsigned long D);
Complex g2(const unsigned long D,const unsigned long a,const unsigned long b,
        const Complex& tau) ;
unsigned long hD1(unsigned long D,unsigned long D1=0);
Complex gamma3(const Complex& tau);
Complex gamma2(const Complex& tau);

Complex f(const Complex& tau) ;
Complex f1(const Complex& tau) ;
Complex f2(const Complex& tau) ;
PolyC P ;
vector< Complex > root ;
Complex eta(Complex tau);

unsigned long index_s(unsigned long D) ;

int geti(int D)
{
    int d=D%8;
    if (d==1 || d==2 || d==6 || d==7) return 3;
    if (d==3)
    {
       if (D%3==0) return 2;
       else        return 0;
    }
    if (d==5) return 6;
    return 0;
}

int getk(int D)
{
    int d=D%8;
    if (d==1 || d==2 || d==6) return 2; //D/4=1 mod 8
    if (d==3 || d==7) return 1;         // D=7 mod 8
    if (d==5) return 4;
    return 0;
}




//Complex classpoly(int A,int B,int C, int D)
Complex classpoly(int A,int B,int C, int D,Complex& tau)
{
    int g,i,j,k,l,m,n,dm8,ac,a2,c2,t;
    Complex cinv,lam;
    Complex muh ;

#if 0
  if( (D%6)==3 ) {
    cout << endl <<Complex(0,sqrt(Fint(D)))*gamma3(tau);
    return Complex(0,sqrt(Fint(D)))*gamma3(tau) ;
  }
#endif

    g=gcd(long(D),long(3));   // g = 1 ,2,3

    ac=A*C;
    if (ac%2==1)
    {
        j=0;
        l=A-C+A*A*C;
    }
    if (C%2==0)  j=1;
    if (A%2==0)  j=2;


//    t=Complex(Fint(B),sqrt(Fint(D)))/A ;

    if( A&1 ) {
      if( C&1 ) muh=f(tau) ;     // h
      else      muh=f1(tau) ;    // h1
    }
    else muh=f2(tau) ;           // h2

#if 0
    if( A&1 ) {
      if( C&1 ) cout << " f " ;     // h
      else      cout << " f1 " ;
    }
    else cout << " f2 " ;
#endif

//    if( j==0 ) muh=f(tau) ;
//    if( j==1 ) muh=f1(tau) ;
//    if( j==2 ) muh=f2(tau) ;




    if (A%2==0)
    {
        t=(C*C-1)/8;
        if (t%2==0) m=1;
        else        m=-1;
    }
    else
    {
        t=(A*A-1)/8;
        if (t%2==0) m=1;
        else        m=-1;
    }

    dm8=D%8;
    i=geti(D);
    k=getk(D);

    switch (dm8)
    {
    case 1:
    case 2:    n=m;
               if (C%2==0) l=A+2*C-A*C*C;
               if (A%2==0) l=A-C-A*C*C;
               break;
    case 3:    if (ac%2==1) n=1;
               else         n=-m;
               if (C%2==0) l=A+2*C-A*C*C;
               if (A%2==0) l=A-C+5*A*C*C;
               break;
    case 5:    n=1;
               if (C%2==0) l=A-C+A*A*C;
               if (A%2==0) l=A-C-A*C*C;
               break;
    case 6:    n=m;
               if (C%2==0) l=A+2*C-A*C*C;
               if (A%2==0) l=A-C-A*C*C;
               break;
    case 7:    if (ac%2==0) n=1;        // D=7     h/sqrt(2)
               else         n=m;
               if (C%2==0) l=A+2*C-A*C*C;
               if (A%2==0) l=A-C-A*C*C;
               break;

    default: break;
    }
    lam=exp(Complex(0,-k*pi()/24));

#if 0
  cout << endl << " i n,l k " << i <<  " " << n << " " << l<< " " << k;
//  cout << endl << power(power(lam,-B*l),24) ;
    cout << "B*l*k mod 24 " << mod(long(k*B*l),24) ;
#endif

    return cinv=power(n*power(lam,-B*l)*power(Fint(2),Fint(-geti(D))/6)
                     *power(muh,getk(D)),gcd(D,3));

}



// A.12.2


// A.12.3

void HilbertPolynomial(unsigned long D,PolyM& Pm)
{
Init:
  PolyC P ;
  unsigned long h ;
  unsigned long a ;
  unsigned long b ;
  unsigned long B ;
  unsigned long q ;

  Complex e ;
  Complex e2 ;
  Complex tau ;
  Complex ftau ;
  Complex j1 ;
  Fint j2 ;
  Fint sqD ;


Initialize_b:
  P=1 ;
  sqD=sqrt(Fint(D)) ;
  tau=Complex(-Fint(D),sqD)/2 ;
  j1=J(tau) ;
  P*=(PolyC::X-j1) ;
  h=1 ;
  b=D&1 ;
  B=sqrt(D/3.0) ;
Initialize_a:
  q=(b*b+D)/4 ;              // q=ac
  a=b ;
  if( a<=1 ) {
    a=1 ;
    goto Loop_on_a ;
  }
Test:
  if( (q%a)==0 ) {

    tau=Complex(-Fint(b),sqD)/2/a ;
    j1=J(tau) ;
    if( a==b || q/a==a || b==0 ) {
        P*=(PolyC::X-j1) ;
    }
    else {
        P*=(PolyC::X*PolyC::X-2*real(j1)*PolyC::X+norm(j1)) ;
    }
  }
Loop_on_a:
  a++ ;
  if( a*a<=q ) goto Test ;
Loop_on_b:
  b+=2 ;
  if( b<=B ) goto Initialize_a ;
  else {
//  PolyM Pm ;
    int k ;
    Pm=nearInt(real(P[deg(P)])) ;
    for( k=deg(P)-1 ; k>=0 ; k-- ) {
      Pm<<=1 ;
      Pm+=nearInt(real(P[k])) ;
    }
    // check
    Mint cr;
    cr =icubrt(Pm[0]) ;
    if( cr*cr*cr!=Pm[0]) {
        cout << endl << "error" ;
      Error(error) ;
    }
//cout << endl << "diff " << (Pm[0]-cr*cr*cr);


    return  ;
  }


}



#if 0
void Hilb(unsigned long D,PolyM& Pm)
{
Init:
  PolyC P ;
  unsigned long h ;
  unsigned long a ;
  unsigned long b ;
  unsigned long B ;
  unsigned long q ;

  Complex e ;
  Complex e2 ;
  Complex tau ;
  Complex ftau ;
  Complex j1 ;
  Fint j2 ;
  Fint sqD ;

cout << endl << "hilb " ;

Initialize_b:
  P=1 ;
//  tau=Complex(-Fint(D),Fint(sqrt(double(D))))/2 ;
  sqD=sqrt(Fint(D)) ;

  if( (D&3)==0 ) b=0 ;
  else b=1 ;
  tau=Complex(Fint(b),sqD)/2 ;
//cout << endl << "1st " ;
//  tau=Complex(-Fint(D),sqD)/2 ;

  j1=Complex(0,sqD)*gamma3(tau) ;
tau=Complex(Fint(b),sqD)/2 ;
cout << endl << j1/Complex(0,sqD)/gamma3(tau) ;
  P*=(PolyC::X-j1) ;
  h=1 ;
  b=D&1 ;
  B=sqrt(D/3.0) ;
Initialize_a:
  q=(b*b+D)/4 ;              // q=ac
  a=b ;
  if( a<=1 ) {
    a=1 ;
    goto Loop_on_a ;
  }
Test:
  if( (q%a)==0 ) {

    tau=Complex(-Fint(b),sqD)/2/a ;
cout << " other " << " a&1 " << (a&1) <<" " ;
    j1=Complex(0,sqD)*gamma3(tau) ;

tau=Complex(-Fint(b)+4*a,sqD)/2/a ;
cout << endl << j1/Complex(0,sqD)/gamma3(tau) ;

#if 0
    if( a==b || q/a==a || b==0 ) {
cout << " ## " ;
        P*=(PolyC::X-j1) ;
    }
    else {
        P*=(PolyC::X*PolyC::X-2*real(j1)*PolyC::X+norm(j1)) ;
    }
#else
    P*=(PolyC::X-j1) ;
    if( a==b || q/a==a || b==0 ) ;
    else {
cout << " coonj " ;
      tau=Complex(Fint(2*22*2*a)-b,sqD)/2/a ;
      j1=Complex(0,sqD)*gamma3(tau) ;
      P*=(PolyC::X-j1) ;
    }
#endif
  }
Loop_on_a:
  a++ ;
  if( a*a<=q ) goto Test ;
Loop_on_b:
  b+=2 ;
  if( b<=B ) goto Initialize_a ;
  else {
//cout << endl << P ;
//  PolyM Pm ;
    int k ;
    Pm=nearInt(real(P[deg(P)])) ;
    for( k=deg(P)-1 ; k>=0 ; k-- ) {
      Pm<<=1 ;
      Pm+=nearInt(real(P[k])) ;
    }
    return  ;
  }


}

#endif


#if 0
// Atkin-Morain̘_ɂ GAMMA2
void Hilb2(unsigned long D,PolyM& Pm)
{
Init:
  PolyC P ;
  unsigned long h ;
  unsigned long a ;
  unsigned long b ;
  unsigned long B ;
  unsigned long q ;

  Complex e ;
  Complex e2 ;
  Complex tau ;
  Complex ftau ;
  Complex j1 ;
  Fint j2 ;
  Fint sqD ;
  unsigned long z ;


Initialize_b:
  P=1 ;
//  tau=Complex(-Fint(D),Fint(sqrt(double(D))))/2 ;
  sqD=sqrt(Fint(D)) ;
//  tau=Complex(-Fint(D),sqD)/2 ;

//cout << endl << "tau " << tau ;
#if 1
  a=1 ;
  if( (D&3)==0 ) b=0 ;
  else b=1 ;
#endif
  tau=Complex(-Fint(b),sqD)/2 ;
cout << endl << "a b " << a << " " << b ;
  j1=g2(D,a,b,tau) ;
//  j1=gamma2(tau) ;
//  j1=f(tau)/sqrt(Fint(2)) ;
  P*=(PolyC::X-j1) ;
  h=1 ;
  b=D&1 ;
  B=sqrt(D/3.0) ;
Initialize_a:
  q=(b*b+D)/4 ;              // q=ac
  a=b ;
  if( a<=1 ) {
    a=1 ;
    goto Loop_on_a ;
  }
Test:
  if( (q%a)==0 ) {

    tau=Complex(-Fint(b),sqD)/2/a ;
    j1=g2(D,a,b,tau) ;
//    j1=gamma2(tau) ;
//    j1=f(tau)/sqrt(Fint(2)) ;
//cout << endl << j1 ;
    if( a==b || q/a==a || b==0 ) {
        P*=(PolyC::X-j1) ;
    }
    else {
        P*=(PolyC::X*PolyC::X-2*real(j1)*PolyC::X+norm(j1)) ;
    }
  }
Loop_on_a:
  a++ ;
  if( a*a<=q ) goto Test ;
Loop_on_b:
  b+=2 ;
  if( b<=B ) goto Initialize_a ;
  else {
//  PolyM Pm ;
    int k ;
    Pm=nearInt(real(P[deg(P)])) ;
    for( k=deg(P)-1 ; k>=0 ; k-- ) {
      Pm<<=1 ;
      Pm+=nearInt(real(P[k])) ;
    }
//  cout<< endl << "Final polynomial " << P ;
//  cout<< endl << "Final polynomial " << Pm ;
//cout << " error " << abs(tau) ;
    // check
//cout << endl << "diff " << (Pm[0]-cr*cr*cr);


#if 0
    for( int i=deg(Pm) ; i>=0 ; i-- ) {
        cout << endl << i << " " << Pm[i] ;
    }
#endif
    return  ;
  }


}

#endif



#if 0
void Hilb4(unsigned long D,PolyM& Pm)
{
Init:
  PolyC P ;
  unsigned long h ;
  unsigned long a ;
  unsigned long b ;
  unsigned long B ;
  unsigned long q ;

  Complex e ;
  Complex e2 ;
  Complex tau ;
  Complex ftau ;
  Complex j1 ;
  Fint j2 ;
  Fint sqD ;
  unsigned long z ;


Initialize_b:
  P=1 ;
//  tau=Complex(-Fint(D),Fint(sqrt(double(D))))/2 ;
  sqD=sqrt(Fint(D)) ;
//  tau=Complex(-Fint(D),sqD)/2 ;

//cout << endl << "tau " << tau ;
#if 1
  a=1 ;
  if( (D&3)==0 ) b=0 ;
  else b=1 ;
#endif
  tau=Complex(-Fint(b),sqD)/2 ;
cout << endl << "a b " << a << " " << b ;
//  j1=g2(D,a,b,tau) ;
//  j1=gamma2(tau) ;
  j1=f(tau)/sqrt(Fint(2)) ;
  P*=(PolyC::X-j1) ;
  h=1 ;
  b=D&1 ;
  B=sqrt(D/3.0) ;
Initialize_a:
  q=(b*b+D)/4 ;              // q=ac
  a=b ;
  if( a<=1 ) {
    a=1 ;
    goto Loop_on_a ;
  }
Test:
  if( (q%a)==0 ) {

    tau=Complex(-Fint(b),sqD)/2/a ;
//    j1=g2(D,a,b,tau) ;
//    j1=gamma2(tau) ;
    j1=f(tau)/sqrt(Fint(2)) ;
//cout << endl << j1 ;
    if( a==b || q/a==a || b==0 ) {
        P*=(PolyC::X-j1) ;
    }
    else {
        P*=(PolyC::X*PolyC::X-2*real(j1)*PolyC::X+norm(j1)) ;
    }
  }
Loop_on_a:
  a++ ;
  if( a*a<=q ) goto Test ;
Loop_on_b:
  b+=2 ;
  if( b<=B ) goto Initialize_a ;
  else {
//  PolyM Pm ;
    int k ;
    Pm=nearInt(real(P[deg(P)])) ;
    for( k=deg(P)-1 ; k>=0 ; k-- ) {
      Pm<<=1 ;
      Pm+=nearInt(real(P[k])) ;
    }
//  cout<< endl << "Final polynomial " << P ;
//  cout<< endl << "Final polynomial " << Pm ;
//cout << " error " << abs(tau) ;
    // check
//cout << endl << "diff " << (Pm[0]-cr*cr*cr);


#if 0
    for( int i=deg(Pm) ; i>=0 ; i-- ) {
        cout << endl << i << " " << Pm[i] ;
    }
#endif
    return  ;
  }


}

#endif


#if 0
void Hilbs(unsigned long D,PolyM& Pm)
{
Init:
  PolyC P ;
  unsigned long h ;
  unsigned long a ;
  unsigned long b ;
  unsigned long B ;
  unsigned long q ;

  Complex e ;
  Complex e2 ;
  Complex tau ;
  Complex ftau ;
  Complex j1 ;
  Fint j2 ;
  Fint sqD ;
  unsigned long s ;
  s=index_s(D) ;


Initialize_b:
  P=1 ;
//  tau=Complex(-Fint(D),Fint(sqrt(double(D))))/2 ;
  sqD=sqrt(Fint(D)) ;
//  tau=Complex(-Fint(D),sqD)/2 ;
//  a=1 ;
  if( (D&3)==0 ) b=0 ;
  else b=1 ;
  tau=Complex(-Fint(b),sqD)/2 ;

  j1=power(eta(tau)/eta(s*tau),24/(s-1)) ;
  j1=j1+power(Mint(s),12/(s-1))/j1 ;
//  j1=f(tau)/sqrt(Fint(2)) ;
  P*=(PolyC::X-j1) ;
  h=1 ;
  b=D&1 ;
  B=sqrt(D/3.0) ;
Initialize_a:
  q=(b*b+D)/4 ;              // q=ac
  a=b ;
  if( a<=1 ) {
    a=1 ;
    goto Loop_on_a ;
  }
Test:
  if( (q%a)==0 ) {

    tau=Complex(-Fint(b),sqD)/2/a ;
    j1=power(eta(tau)/eta(s*tau),24/(s-1)) ;
    j1=j1+power(Mint(s),12/(s-1))/j1 ;
//    j1=f(tau)/sqrt(Fint(2)) ;
cout << endl << j1 ;
    if( a==b || q/a==a || b==0 ) {
        P*=(PolyC::X-j1) ;
    }
    else {
        P*=(PolyC::X*PolyC::X-2*real(j1)*PolyC::X+norm(j1)) ;
    }
  }
Loop_on_a:
  a++ ;
  if( a*a<=q ) goto Test ;
Loop_on_b:
  b+=2 ;
  if( b<=B ) goto Initialize_a ;
  else {
//  PolyM Pm ;
    int k ;
    Pm=nearInt(real(P[deg(P)])) ;
    for( k=deg(P)-1 ; k>=0 ; k-- ) {
      Pm<<=1 ;
      Pm+=nearInt(real(P[k])) ;
    }


#if 0
    for( int i=deg(Pm) ; i>=0 ; i-- ) {
        cout << endl << i << " " << Pm[i] ;
    }
#endif
    return  ;
  }


}

#endif

void WP_new(unsigned long D,PolyM& Pm)
{
Init:
  PolyC P ;
  unsigned long h ;
  unsigned long a ;
  unsigned long c ;
  unsigned long b ;
  unsigned long B ;
  unsigned long q ;
//  unsigned long z ;

  Complex e ;
  Complex e2 ;
  Complex tau ;
  Complex ftau ;
  Complex j1 ;
  Fint j2 ;
  Fint sqD ;


Initialize_b:
  P=1 ;
//  tau=Complex(-Fint(D),Fint(sqrt(double(D))))/2 ;
  sqD=sqrt(Fint(D)) ;
  tau=Complex(-Fint(0),sqD) ;
  a=1 ; b=0 ; c=D ;
//cout << endl << " a b c " << a << " " << b << " " << c ;
//  j1=classpoly(a,b,D,D) ;
//  P*=(PolyC::X-j1) ;
  h=1 ;
//  b=D&1 ;
  b=0 ;
  B=sqrt(D/3.0) ;
Initialize_a:
  q=(b*b+D) ;              // q=ac
  a=2*b ;
  if( a<=1 ) {
    a=1 ;
//    goto Loop_on_a ;
  }
Test:
  if( (q%a)==0 && gcd(gcd(a,2*b),c=q/a)==1 ) {
    tau=Complex(Fint(b),sqD)/a ;
//    tau=Complex(-2*Fint(b),sqD)/a ;
//c=q/a ;
//cout << endl << " a b c " << a << " " << b << " " << c ;
//cout << endl << (sqD/2/a) ;
//cout << endl << " tau " << tau ;
if( a*c-b*b!=D ) Error(a*c-b*b!=D) ;
    j1=classpoly(a,b,c,D,tau) ;
//j1=gamma2(tau) ;
//j1=Weber(D,a,b,tau) ;
    if( a==2*b || q/a==a || b==0 ) {
        P*=(PolyC::X-j1) ;
    }
    else {
        P*=(PolyC::X*PolyC::X-2*real(j1)*PolyC::X+norm(j1)) ;
    }
  }
Loop_on_a:
  a++ ;
  if( a*a<=q ) goto Test ;
Loop_on_b:
//  b+=2 ;
  b++ ;
  if( b<=B ) goto Initialize_a ;
  else {
//  PolyM Pm ;
//cout << endl << P ;
    int k ;
    Pm=nearInt(real(P[deg(P)])) ;
    for( k=deg(P)-1 ; k>=0 ; k-- ) {
      Pm<<=1 ;
      Pm+=nearInt(real(P[k])) ;
    }


#if 0
    for( int i=deg(Pm) ; i>=0 ; i-- ) {
        cout << endl << i << " " << Pm[i] ;
    }
#endif
    return  ;
  }


}


void WP4(unsigned long D,PolyM& Pm)
{
cout << endl << "WP4 " ;
Pm=1 ;
return ;
Init:
  PolyC P ;
  unsigned long h ;
  unsigned long a ;
  unsigned long c ;
  unsigned long b ;
  unsigned long B ;
  unsigned long q ;
//  unsigned long z ;

  Complex e ;
  Complex e2 ;
  Complex tau ;
  Complex ftau ;
  Complex j1 ;
  Fint j2 ;
  Fint sqD ;


Initialize_b:
  P=1 ;
//  tau=Complex(-Fint(D),Fint(sqrt(double(D))))/2 ;
  sqD=sqrt(Fint(D)) ;
  tau=Complex(-Fint(0),sqD) ;
  a=1 ; b=0 ; c=D ;
//cout << endl << " a b c " << a << " " << b << " " << c ;
//  j1=classpoly(a,b,D,D) ;
//  P*=(PolyC::X-j1) ;
  h=1 ;
//  b=D&1 ;
  b=0 ;
  B=sqrt(D/3.0) ;
Initialize_a:
  q=(b*b+D) ;              // q=ac
  a=2*b ;
  if( a<=1 ) {
    a=1 ;
//    goto Loop_on_a ;
  }
Test:
  if( (q%a)==0 && gcd(gcd(a,2*b),c=q/a)==1 ) {
    tau=Complex(Fint(b),sqD)/a ;
//    tau=Complex(-2*Fint(b),sqD)/a ;
//c=q/a ;
//cout << endl << " a b c " << a << " " << b << " " << c ;
//cout << endl << (sqD/2/a) ;
//cout << endl << " tau " << tau ;
if( a*c-b*b!=D ) Error(a*c-b*b!=D) ;
     j1=f(tau)/sqrt(Fint(2)) ;
//    j1=classpoly(a,b,c,D,tau) ;
//j1=gamma2(tau) ;
//j1=Weber(D,a,b,tau) ;
    if( a==2*b || q/a==a || b==0 ) {
        P*=(PolyC::X-j1) ;
    }
    else {
        P*=(PolyC::X*PolyC::X-2*real(j1)*PolyC::X+norm(j1)) ;
    }
  }
Loop_on_a:
  a++ ;
  if( a*a<=q ) goto Test ;
Loop_on_b:
//  b+=2 ;
  b++ ;
  if( b<=B ) goto Initialize_a ;
  else {
//  PolyM Pm ;
//cout << endl << P ;
    int k ;
    Pm=nearInt(real(P[deg(P)])) ;
    for( k=deg(P)-1 ; k>=0 ; k-- ) {
      Pm<<=1 ;
      Pm+=nearInt(real(P[k])) ;
    }


#if 0
    for( int i=deg(Pm) ; i>=0 ; i-- ) {
        cout << endl << i << " " << Pm[i] ;
    }
#endif
    return  ;
  }


}


void WP_new1(unsigned long D,PolyM& Pm)
{
Init:
  PolyC P ;
  unsigned long h ;
  unsigned long a ;
  unsigned long c ;
  unsigned long b ;
  unsigned long B ;
  unsigned long q ;
//  unsigned long z ;

  Complex e ;
  Complex e2 ;
  Complex tau ;
  Complex ftau ;
  Complex j1 ;
  Fint j2 ;
  Fint sqD ;


Initialize_b:
  P=1 ;
//  tau=Complex(-Fint(D),Fint(sqrt(double(D))))/2 ;
  sqD=sqrt(Fint(D)) ;
  tau=Complex(-Fint(0),sqD) ;
  a=1 ; b=0 ; c=D ;
//cout << endl << " a b c " << a << " " << b << " " << c ;
//  j1=classpoly(a,b,D,D) ;
//  P*=(PolyC::X-j1) ;
  h=1 ;
//  b=D&1 ;
  b=0 ;
  B=sqrt(D/3.0) ;
Initialize_a:
  q=(b*b+D) ;              // q=ac
  a=2*b ;
  if( a<=1 ) {
    a=1 ;
//    goto Loop_on_a ;
  }
Test:
  if( (q%a)==0 && gcd(gcd(a,2*b),c=q/a)==1 ) {
    tau=Complex(Fint(b),sqD)/a ;
//    tau=Complex(-2*Fint(b),sqD)/a ;
//c=q/a ;
//cout << endl << " a b c " << a << " " << b << " " << c ;
//cout << endl << (sqD/2/a) ;
//cout << endl << " tau " << tau ;
if( a*c-b*b!=D ) Error(a*c-b*b!=D) ;
    j1=Complex(0,sqD)*gamma3(tau) ;
//    j1=classpoly(a,b,c,D,tau) ;
//j1=gamma2(tau) ;
//j1=Weber(D,a,b,tau) ;
    if( a==2*b || q/a==a || b==0 ) {
        P*=(PolyC::X-j1) ;
    }
    else {
        P*=(PolyC::X*PolyC::X-2*real(j1)*PolyC::X+norm(j1)) ;
    }
  }
Loop_on_a:
  a++ ;
  if( a*a<=q ) goto Test ;
Loop_on_b:
//  b+=2 ;
  b++ ;
  if( b<=B ) goto Initialize_a ;
  else {
//  PolyM Pm ;
//cout << endl << P ;
    int k ;
    Pm=nearInt(real(P[deg(P)])) ;
    for( k=deg(P)-1 ; k>=0 ; k-- ) {
      Pm<<=1 ;
      Pm+=nearInt(real(P[k])) ;
    }


#if 0
    for( int i=deg(Pm) ; i>=0 ; i-- ) {
        cout << endl << i << " " << Pm[i] ;
    }
#endif
    return  ;
  }


}


#if 0

void WP_new1(unsigned long D,PolyM& Pm)
{
Init:
  PolyC P ;
  unsigned long h ;
  unsigned long a ;
  unsigned long c ;
  unsigned long b ;
  unsigned long B ;
  unsigned long q ;

  Complex e ;
  Complex e2 ;
  Complex tau ;
  Complex ftau ;
  Complex j1 ;
  Fint j2 ;
  Fint sqD ;


Initialize_b:
  P=1 ;
//  tau=Complex(-Fint(D),Fint(sqrt(double(D))))/2 ;
  sqD=sqrt(Fint(D)) ;
  tau=Complex(-Fint(0),sqD) ;
  a=1 ; b=0 ; c=D ;
//cout << endl << " a b c " << a << " " << b << " " << c ;
//  j1=classpoly(a,b,D,D) ;
//  P*=(PolyC::X-j1) ;
  h=1 ;
//  b=D&1 ;
  b=0 ;
  B=sqrt(D/3.0) ;
Initialize_a:
  q=(b*b+D) ;              // q=ac
  a=2*b ;
  if( a<=1 ) {
    a=1 ;
//    goto Loop_on_a ;
  }
Test:
  if( (q%a)==0 && gcd(gcd(a,2*b),c=q/a)==1 ) {
    tau=Complex(Fint(b),sqD)/a ;
//c=q/a ;
//cout << endl << " a b c " << a << " " << b << " " << c ;
//cout << endl << (sqD/2/a) ;
//cout << endl << " tau " << tau ;
//  j1=classpoly(a,b,c,D,tau) ;
j1=Weber(D,a,b,tau) ;
    if( a==2*b || q/a==a || b==0 ) {
        P*=(PolyC::X-j1) ;
    }
    else {
        P*=(PolyC::X*PolyC::X-2*real(j1)*PolyC::X+norm(j1)) ;
    }
  }
Loop_on_a:
  a++ ;
  if( a*a<=q ) goto Test ;
Loop_on_b:
//  b+=2 ;
  b++ ;
  if( b<=B ) goto Initialize_a ;
  else {
//  PolyM Pm ;
//cout << endl << P ;
    int k ;
    Pm=nearInt(real(P[deg(P)])) ;
    for( k=deg(P)-1 ; k>=0 ; k-- ) {
      Pm<<=1 ;
      Pm+=nearInt(real(P[k])) ;
    }


#if 0
    for( int i=deg(Pm) ; i>=0 ; i-- ) {
        cout << endl << i << " " << Pm[i] ;
    }
#endif
    return  ;
  }


}

#endif



void WP(unsigned long D)
{
Init:
  PolyC P,Q ;
  unsigned long h ;
  unsigned long a ;
  unsigned long b ;
  unsigned long c ;
  unsigned long B ;
  unsigned long q ;

  Complex e ;
  Complex e2 ;
  Complex tau ;
  Complex ftau ;
  Complex j1 ;
  Fint j2 ;
  Fint sqD ;

  P=1 ;
  sqD=sqrt(Fint(D)) ;
  B=sqrt(double(D)/3.0) ;
  for( b=0 ; b<=B ; b++ ) {
    q=(b*b+D) ;
    a=2*b ;
    if( a==0 ) a++ ;
    for(;;) {
      while( q%a!=0 ) {
        a++ ;
        if( a*a>q ) break ;
      }
      if( a*a>q ) break ;
      c=q/a ;
      if( gcd(gcd(a,2*b),c)==1 ) {
        tau=Complex(-2*Fint(b),sqD)/a ;
//cout << endl << " a b c " << a << " " << b << " " << c ;
//cout << endl << (sqD/2/a) ;
//cout << endl << " tau " << tau ;
        j1=classpoly(a,b,c,D,tau) ;
        if( q/a==a || b==0 || a==2*b ) {
           P*=(PolyC::X-j1) ;
        }
        else {
          P*=(PolyC::X*PolyC::X-2*real(j1)*PolyC::X+norm(j1)) ;
        }

      }
      a++ ;
    }

  }

//  cout << endl << "P " << P ;
  PolyM Pm ;
  int k;
  Pm=nearInt(real(P[deg(P)])) ;
  for( k=deg(P)-1 ; k>=0 ; k-- ) {
    Pm<<=1 ;
    Pm+=nearInt(real(P[k])) ;
  }

}



#if 0

unsigned long hD(unsigned long D,unsigned long D1)
{
  unsigned long h ;
//  unsigned long a ;
//  unsigned long b ;
  unsigned long B ;
//  unsigned long q ;
//  unsigned long q0,q1 ;
  unsigned long c4(4) ;
  double dD ;
Initialize_b:
//  h=1 ;
//  b=D&1 ;

  dD=double(0xffffffffUL) ;
  dD+=1.0 ;
  dD*=double(D1) ;
  dD+=double(D) ;
  B=sqrt(dD/3.0) ;
  __asm {
    mov h,1
    mov ecx,D
    and ecx,1
  }
//  __asm mov ecx,b
Initialize_a:
//  q=(b*b+D)/4 ;
  __asm {
    mov eax,ecx    // ecx=b
    mul ecx
    add eax,D
    adc edx,D1

    shrd eax,edx,2
    shr  edx,2
//  div c4
//or edx,edx
//jnz ERROR
    mov esi,eax
    mov edi,edx       // q= edi:esi
  }  // edx,eax=q
  __asm {
    mov ebx,ecx       // a <- b
//  mov ebx,b
    cmp ebx,1         // a<=1 ?
    ja  Test
    mov ebx,1        // a <- 1
    jmp Loop_on_a
  }
//  a=b ;
//  if( a<=1 ) {
//    a=1 ;
//    goto Loop_on_a ;
//  }
Test:
  __asm {
    mov edx,edi
    mov eax,esi
    div ebx
    or  edx,edx
    jnz Loop_on_a
    cmp ebx,ecx    // a=b ?
    je  INC_1
    or   ecx,ecx    // b=0 ?
    jz   INC_1

    mov  eax,ebx
    mul  ebx
    cmp  esi,eax
    jne  INC_2
    cmp  edi,edx
    je   INC_1
  }
INC_2:
   __asm {
    inc  h
  }
INC_1:
  __asm {
    inc h
  }
//  if( (q%a)==0 ) {
//    if( a==b || a*a==q || b==0 ) h++ ;
//    else h+=2 ;
//  }
Loop_on_a:
//  a++ ;
  __asm {
    inc ebx
    mov eax,ebx
    mul ebx
    cmp edx,edi
    ja   Loop_on_b
    jb   Test
    cmp  eax,esi
    ja   Loop_on_b
    jmp  Test
  }
//  if( a*a<=q ) goto Test ;
Loop_on_b:
  __asm {
    inc ecx          // b+=2
    inc ecx
    cmp ecx,B
    jbe  Initialize_a
  }
  return h ;
//  b+=2 ;
//  if( b<=B ) goto Initialize_a ;
//  else {
//    return h ;
//  }

ERROR:
//  return 0 ;

}
#endif
#if 1
unsigned long hDsum1(unsigned long D,double& sum)
{
  unsigned long h ;
  unsigned long a ;
  unsigned long b ;
  unsigned long B ;
  unsigned long q ;


  sum=0 ;

Initialize_b:
//  tau=Complex(-Fint(D),Fint(sqrt(double(D))))/2 ;
  h=1 ;
  b=D&1 ;
  B=sqrt(D/3.0) ;
Initialize_a:
  q=(b*b+D)/4 ;
  a=b ;
  if( a<=1 ) {
    a=1 ;
    goto Loop_on_a ;
  }
Test:
  if( (q%a)==0 ) {

    if( a==b || q/a==a || b==0 ) {
        h++ ;
    }
    else {
        h+=2 ;
    }
    sum+=1.0/a ;
//  cout << endl << "PolyC " << P ;
  }
Loop_on_a:
  a++ ;
  if( a*a<=q ) goto Test ;
Loop_on_b:
  b+=2 ;
  if( b<=B ) goto Initialize_a ;
  else {


    return h ;
  }


}
#endif

#if 0
unsigned long hDsum(unsigned long D,unsigned long D1,double& suma)
{
  unsigned long h ;
  unsigned long a ;
//  unsigned long b ;
  unsigned long B ;
//  unsigned long q ;
//  unsigned long q0,q1 ;
  unsigned long c4(4) ;
  suma=0.0 ;
  double dD ;
Initialize_b:
//  h=1 ;
//  b=D&1 ;

  dD=double(0xffffffffUL) ;
  dD+=1.0 ;
  dD*=double(D1) ;
  dD+=double(D) ;
  B=sqrt(dD/3.0) ;
  __asm {
    mov h,1
    mov ecx,D
    and ecx,1
  }
//  __asm mov ecx,b
Initialize_a:
//  q=(b*b+D)/4 ;
  __asm {
    mov eax,ecx    // ecx=b
    mul ecx
    add eax,D
    adc edx,D1

    shrd eax,edx,2
    shr  edx,2
//  div c4
//or edx,edx
//jnz ERROR
    mov esi,eax
    mov edi,edx       // q= edi:esi
  }  // edx,eax=q
  __asm {
    mov ebx,ecx       // a <- b
//  mov ebx,b
    cmp ebx,1         // a<=1 ?
    ja  Test
    mov ebx,1        // a <- 1
    jmp Loop_on_a
  }
//  a=b ;
//  if( a<=1 ) {
//    a=1 ;
//    goto Loop_on_a ;
//  }
Test:
  __asm {
    mov edx,edi
    mov eax,esi
    div ebx
    or  edx,edx
    jnz Loop_on_a
    cmp ebx,ecx    // a=b ?
    je  INC_1
    or   ecx,ecx    // b=0 ?
    jz   INC_1

    mov  eax,ebx
    mul  ebx
    cmp  esi,eax
    jne  INC_2
    cmp  edi,edx
    je   INC_1
  }
INC_2:
   __asm {
    inc  h
  }
INC_1:
  __asm {
    inc h
    mov a,ebx
    push ecx
    push eax
  }

  suma+=1.0/a ;
  __asm {
    pop eax
    pop ecx
}

//  if( (q%a)==0 ) {
//    if( a==b || a*a==q || b==0 ) h++ ;
//    else h+=2 ;
//  }
Loop_on_a:
//  a++ ;
  __asm {
    inc ebx
    mov eax,ebx
    mul ebx
    cmp edx,edi
    ja   Loop_on_b
    jb   Test
    cmp  eax,esi
    ja   Loop_on_b
    jmp  Test
  }
//  if( a*a<=q ) goto Test ;
Loop_on_b:
  __asm {
    inc ecx          // b+=2
    inc ecx
    cmp ecx,B
    jbe  Initialize_a
  }
  return h ;
//  b+=2 ;
//  if( b<=B ) goto Initialize_a ;
//  else {
//    return h ;
//  }

ERROR:
//  return 0 ;

}


#endif

#if 0

unsigned long hD1(unsigned long D,unsigned long D1)
{
  unsigned long h ;
  unsigned long B ;
  unsigned long c4(4) ;
  double dD ;
Initialize_b:

  dD=double(0xffffffffUL) ;
  dD+=1.0 ;
  dD*=double(D1) ;
  dD+=double(D) ;
  B=sqrt(dD/3.0) ;
  __asm {
    mov h,1
    mov ecx,D
    and ecx,1
  }
//  __asm mov ecx,b
Initialize_a:
//  q=(b*b+D)/4 ;
  __asm {
    mov eax,ecx    // ecx=b
    mul ecx
    add eax,D
    adc edx,D1

    shrd eax,edx,2
    shr  edx,2
//  div c4
//or edx,edx
//jnz ERROR
    mov esi,eax
    mov edi,edx       // q= edi:esi
  }  // edx,eax=q
  __asm {
    mov ebx,ecx       // a <- b
//  mov ebx,b
    cmp ebx,1         // a<=1 ?
    ja  Test
    mov ebx,1        // a <- 1
    jmp Loop_on_a
  }
//  a=b ;
//  if( a<=1 ) {
//    a=1 ;
//    goto Loop_on_a ;
//  }
Test:
  __asm {
    mov edx,edi
    mov eax,esi
    div ebx
    or  edx,edx
    jnz Loop_on_a
    cmp ebx,ecx    // a=b ?
    je  INC_1
    or   ecx,ecx    // b=0 ?
    jz   INC_1

    mov  eax,ebx
    mul  ebx
    cmp  esi,eax
    jne  INC_2
    cmp  edi,edx
    je   INC_1
  }
INC_2:
   __asm {
    inc  h
  }
INC_1:
  __asm {
    inc h
  }
//  if( (q%a)==0 ) {
//    if( a==b || a*a==q || b==0 ) h++ ;
//    else h+=2 ;
//  }
Loop_on_a:
//  a++ ;
  __asm {
    inc ebx
    mov eax,ebx
    mul ebx
    cmp edx,edi
    ja   Loop_on_b
    jb   Test
    cmp  eax,esi
    ja   Loop_on_b
    jmp  Test
  }
//  if( a*a<=q ) goto Test ;
Loop_on_b:
  __asm {
    inc ecx          // b+=2
    inc ecx
    cmp ecx,B
    jbe  Initialize_a
  }
  return h ;
//  b+=2 ;
//  if( b<=B ) goto Initialize_a ;
//  else {
//    return h ;
//  }

ERROR:
//  return 0 ;

}

#endif

unsigned long isDisc(const unsigned long D)
{

  unsigned long d ;
  if( (D&3)==3 ) return D ;
  else if( (D&3)==0 ) return D/4 ;


}


#if 1
// is fundamental discriminant
bool isNegDisc(unsigned long D)
{
  unsigned long q ;
  unsigned long D4 ;
  if( D==1 ) return false ;

  if( (D&3)==3 ) {
    for(;;) {
      q=prmdiv(D) ;
      if( q==1 ) return true ;
      D/=q ;
      if( D%q==0 ) return false ;
      if( D==1 ) return true ;
    }
  }

  if( (D&3)==0 ) {
    D4=(D>>=2) ;
    for(;;) {
      q=prmdiv(D4) ;
      if( q==1 ) break  ;
      D4/=q ;
      if( D4%q==0 ) return false ;
      if( D4==1 ) break ;
    }
    return true ;
//    if( (D4&3)==1 || (D4&3)==2 ) return true ;
//    else return false ;
  }

  return false ;
}

#else
bool isNegDisc(unsigned long D)
{
  unsigned long q ;
  unsigned long D4 ;
  if( D==1 ) return false ;

  if( D%4==0 ) return false ;
  if( (D&3)==3 ) {
    for(;;) {
      q=prmdiv(D) ;
      if( q==1 ) return true ;
      D/=q ;
      if( D%q==0 ) return false ;
      if( D==1 ) return true ;
    }
  }

  if( (D&3)==0 ) {
    D4=(D>>=2) ;
    for(;;) {
      q=prmdiv(D) ;
      if( q==1 ) break  ;
      D/=q ;
      if( D%q==0 ) return false ;
      if( D==1 ) break ;
    }
    if( (D4&3)==1 || (D4&3)==2 ) return true ;
    else return false ;
  }

  return false ;
}
#endif


// f <-> h
Complex f(const Complex& tau)
{
  Complex zeta ;
  zeta=exp(Complex(0,-2*pi()/48)) ;
  return zeta*eta((tau+1)/2)/eta(tau) ;

}

// f1 <-> h1
Complex f1(const Complex& tau)
{
  return eta(tau/2)/eta(tau) ;
}

// f2<-> h2
Complex f2(const Complex& tau)
{
  return sqrt(Fint(2))*eta(2*tau)/eta(tau) ;
}

Complex gamma2(const Complex& tau)
{
  Complex ftau=f(tau) ;
  return (power(ftau,24)-16)/power(ftau,8) ;
}

Complex gamma3(const Complex& tau)
{
  Complex ftau=f(tau) ;
  return (power(ftau,24)+8)*(power(f1(tau),8)-power(f2(tau),8))/power(ftau,8) ;
}


void Weber(const unsigned long D,PolyM& Pm)
{

    if( D%3!=0 && D%8!=3 ) {


      if( (D&3)==0 ) {
        WP_new(D/4,Pm) ;
      }
      else {
        WP_new(D,Pm) ;
      }
    }
#if 0
    else if( index_s(D)!=0 ) {
   cout << endl << "s " << index_s(D) ;
        Hilbs(D,Pm) ;
          cout << endl << Pm ;
    }
#endif
    else if( D%8==3 && D%6!=3 ) {
#if 0
       WP_new(D,Pm) ;
#else
       HilbertPolynomial(D,Pm) ;
//      Hilb2(D,Pm) ;
#endif
    }
#if 0
    else if( D%6==3 ) {
      Hilb(D,Pm) ;
    }
#else
    else if( D%6==3 ) HilbertPolynomial(D,Pm) ;
#endif
    else {
      if( D%3!=0 ) Hilb2(D,Pm) ;
      else HilbertPolynomial(D,Pm) ;
      cout << endl << "Pm " << Pm ;
//    return 1 ;
    }




}

Complex Weber(const unsigned long D,const unsigned long a,const unsigned long b,
              const Complex& tau)
{
  unsigned long s ;
  Complex xs ;


#if 1
//    return Complex(0,sqrt(Fint(D)))*gamma3(tau) ;

//  if( D%3!=0 && b%3==0 && a%3!=0 ) {
//      return g2(D,a,b,tau) ;
//  }
  if( D%3!=0 && (D&7)!=3 ) {

    if( (D&7)==7 ) {
//      return Complex(0,sqrt(Fint(D)))/sqrt(Fint(2)) ;
//return gamma2(tau) ;
//      return g2(D,a,b,tau) ;
      return f(tau)/sqrt(Fint(2)) ;
    }
    else if( (D&7)==3 )
      return f(tau) ;
    else if( ((D/4)&7)==2 || ((D/4)&7)==6 ) {
      return f1(tau)/sqrt(Fint(2)) ;
    }
    else if( ((D/4)&7)==5 ) {
      return power(f(tau),4) ;
    }
    else if( ((D/4)&7)==1   ) {
      return power(f(tau),2)/sqrt(Fint(2))  ;
    }
  }

#if 0
  for( s=3 ; s<=13 ; ) {
s=110 ;
    if( Kronecker(s-D%s,s)==1 ) break ;
    if( s==3 ) s=5 ;
    else if( s==5 ) s=7 ;
    else if( s==7 ) s=13 ;
    else s=17 ;
  }
  if( s<=13 ) {
//  cout << endl << " s " << s ;
    xs=power(eta(tau)/eta(s*tau),24/(s-1)) ;
    return xs+Complex(power(Mint(s),12/(s-1)))/xs ;
//    return power(eta(tau)/eta(s*tau),24/(s-1)) ;
  }
#endif
  if( (D%6)==3 ) {
//cout << endl << "gamma3 " ;
//    return f(tau) ;
    return Complex(0,sqrt(Fint(D)))*gamma3(tau) ;
  }
  return J(tau) ;


#else

  if( (D%6)==3 ) {
    return Complex(0,sqrt(Fint(D)))*gamma3(tau) ;
  }
  else if( (D&7)==7 ) {
    return f(tau)/sqrt(Fint(2)) ;
  }
  else if( (D&7)==3 ) {
    return f(tau) ;
  }
  else if( ((D/4)&7)==2 || ((D/4)&7)==6 ) {
    return f1(tau)/sqrt(Fint(2)) ;

  }
  else if( ((D/4)&7)==5 ) {
    return power(f(tau),4) ;
  }
  else if( ((D/4)&7)==1 ) {
    return power(f(tau),2)/sqrt(Fint(2))  ;
  }
  else {
    return J(tau) ;
  }
#endif
}



unsigned long index_s(unsigned long D)
{
  unsigned long ss[]={13,7,5,3} ;
  int j ;
  unsigned long s ;
  for( j=0 ; j<4 ; j++ ) {
    s=ss[j] ;
    if( Kronecker(s-D%s,s)==1 ) return s ;
  }
  return 0 ;
}


Complex g2(const unsigned long D,const unsigned long a,const unsigned long b,
        const Complex& tau)
{
  unsigned long k ;
  unsigned long A,B,C ;
  unsigned long c ;

  if( (a%3)!=0 ) {
    k=(3-b%3)*invmodp(2*a,3UL) ;
  }
  else if( (b%3)!=0 ) {
    c=(b*b+D)/a/4 ;
    k=((3-c%3)*invmodp(b,3UL))%3 ;
  }
  else k=0 ;

#if 0
cout << endl << "k " << k ;
cout << endl << "real(g2) " << nearInt(real(gamma2(tau))) ;
cout << endl << "real(g2) " << nearInt(real(exp(Complex(0,2*1*pi()/3))*gamma2(tau))) ;
cout << endl << "real(g2) " << nearInt(real(exp(Complex(0,2*2*pi()/3))*gamma2(tau))) ;
#endif
  return exp(Complex(0,2*k*pi()/3))*gamma2(tau) ;
}


Complex delta(Complex& tau)
{
  Complex e ;
  Complex q ;
//  Complex i=Complex(0,1) ;
  Complex q1,q2 ;
  Complex g ;
  Complex d ;
  unsigned long n ;
  double suma ;
  Fint rho ;

  e=2*pi()*tau ;
  q=Complex(-imag(e),real(e)) ;
  q=exp(q) ;
//  q=sqrt(q) ;
  d=1 ;
//  rho=abs(q) ;
  for( n=1 ; ; n++ ) {
    g=power(q,n*(3*n-1)/2)+power(q,n*(3*n+1)/2) ;
    if( g==0 ) break ;
    if( n&1 ) d-=g ;
    else      d+=g ;
  }
  d=q*power(d,24) ;
//cout << endl << "delta/eta^24" << (d/power(eta(tau),24))  ;
  return d ;
}


//
// Algorithm 6.3.2 (Computation of \eta(\tau)
//  Given \tau in the upper half plane H, this algorithm computes the valu of \eta(\tau)
//
// using the action by PSL(Z)
//
Complex eta(Complex tau)
{
  Complex p,q,q1,qn,qs ;
  Complex zeta ;
  Complex s,t ;
  Complex sqitau ;
  Mint n ;
  Fint m ;

Initialization:
  zeta=exp(Complex(0,pi()/12)) ;
  p=1 ;

Reduce_real_part:
  for(;;) {
    n=nearInt(real(tau)) ;
    if( n!=0 ) {           // translation
      tau-=n ;
      p*=power(zeta,n) ;
    }
Inverse:
    m=norm(tau) ;
//  if( m<1 && m1<m ) {
    if( m>=1 || ndigit(m-1)<2 ) break ;
//    if( m<1 && ndigit(m-1)>1 ) {   // less than 1 and not near 1
//cout << endl << "m " << m;
#if 1                                     // inversion
    sqitau=sqrt(Complex(0,1)/tau) ;
    if( sign(real(sqitau))<0 ) sqitau=-sqitau ;
    p*=sqitau  ;
#else
    p*=sqrt(Complex(0,1)/tau)  ;
#endif
    tau=-conj(tau)/m ;
//      goto Reduce_real_part ;
  }

Start_computaion_of_eta:
  q1=pi()*tau/12 ;
  q1=Complex(-imag(q1),real(q1)) ;
  q1=exp(q1) ;                      // exp(2*\pi*i*\tau/24)
  q=power(q1,24) ;
  s=1 ;
  qs=1 ;
  qn=1 ;
Main_loop:
//cout << endl << q ;
  while( qs!=0 ) {
    t=-q*qn*qn*qs ;
    qn*=q ;
    qs=qn*t ;
    s+=(t+qs) ;
//cout << endl << t ;
//cout << endl << qs ;
  }
Finished:
  return p*q1*s ;





}


#if 0

Complex eta1(Complex& tau)
{
  Complex e ;
  Complex etau ;
  Complex q ;
  Complex q1,q2 ;
  Complex g ;
  Complex d ;
  unsigned long n ;
  double suma ;

  e=2*pi()*tau ;
  etau=Complex(-imag(e),real(e)) ;
  q=exp(etau) ;
  etau/=24 ;
  etau=exp(etau) ;
  d=1 ;
  for( n=1 ; ; n++ ) {
    g=power(q,n*(3*n-1)/2)+power(q,n*(3*n+1)/2) ;
    if( g==0 ) break ;
    if( n&1 ) d-=g ;
    else      d+=g ;
  }
  d=etau*d ;

  #if 0
  e=d/eta1(tau)-1 ;
  if( 2*abs(real(e))>1 ) {
    cout << endl << real(d/eta1(tau)) ;
    Error(abs(real(e))>0.5) ;
  }



  #endif
  return d ;
}

#endif

Complex J(Complex& tau)
{
  Complex ftau=delta(2*tau)/delta(tau) ;
  return power(256*ftau+1,3)/ftau ;
}

void JmodN(Mint& R,Mint& N,unsigned long D,Mint& j)
{

    unsigned long d=isDisc(D) ;

    Mint h24 ;
    if( D%3!=0 && D%8!=3 ) {


      if( (D&3)==0 ) {
        D>>=2 ;
        h24=power(R,Mint(24)/gcd(D,3)/getk(D),N) ;
        h24*=power(Mint(2),24*geti(D)/gcd(D,3)/6/getk(D)) ;
        h24%=N ;
        if( D%8==2 || D%8==6 ) h24=-h24 ;
        j=power(h24-16,Mint(3),N)*invmodp(h24,N)%N  ;
      }
      else {
        h24=power(R,Mint(24)/gcd(D,3)/getk(D),N) ;
        h24*=power(Mint(2),24*geti(D)/gcd(D,3)/6/getk(D)) ;
        h24%=N ;
        h24=-power(Mint(2),12)*invmodp(h24,N) ;
        j=power(h24+16,Mint(3),N)*invmodp(h24,N)%N ;
      }
    }
    else if( D%8==3 && D%6!=3  ) {
#if 0
      h24=power(R,Mint(24)/gcd(D,3)/getk(D),N) ;
      h24*=power(Mint(2),24*geti(D)/gcd(D,3)/6/getk(D)) ;
      h24%=N ;
      h24=-power(Mint(2),12)*invmodp(h24,N) ;
      j=power(h24+16,Mint(3),N)*invmodp(h24,N)%N ;
#else
       j=R ;              // Hilbert polynomial gꍇ
#endif
    }
    else if( D%6==3 ) {

      j=R;
    }
    else {
      if( D%3!=0 ) j=power(R,3)%N ;
      else  j=R;
    }

}





bool isaD(int d,int pm8,int k)
{
   int i,dm8;
   bool sqr;
   dm8=d%8;
   if (k==1 && dm8!=3) return false;
   if ((k==2 || k==3) && dm8==7) return false;
   if (pm8==3 && (dm8==1 || dm8==4 || dm8==5 || dm8==6)) return false;
   if (pm8==5 && dm8%2==0) return false;
   if (pm8==7 && (dm8==1 || dm8==2 || dm8==4 || dm8==5)) return false;
   sqr=false;
   for (i=2;;i++)
   {
       if (d%(i*i)==0)
       {
           sqr=true;
           break;
       }
       if (i*i>d) break;
   }
   if (sqr) return false;
   return true;
}



void cal(Mint& R,unsigned long D,Mint& J)
{
  Mint V ;
  V=power(R,24/gcd(D,3)/getk(D)) ;
  V*=power(Mint(2),4*geti(D)) ;
  if( D&1 ) ~V ;
  J=V ;
}

#if 0
void calf(Complex& R,unsigned long D,Complex& j)
{
//  J=R; return ;

  Complex h24;
  if( D%6==3 ) {
cout << endl << "D%6=3 " << D ;

//    j=(-power(Complex(0,sqrt(Fint(D)))*R,2)/D+1728) ;
//cout << endl << "J " << nearInt(real(J(Complex(Fint(-1),sqrt(Fint(D)) )/2 ))) ;
    j=-R*R/D+1728 ;

  }
  else {
    h24=power(R,24/gcd(D,3)/getk(D)) ;
    h24*=power(Mint(2),24*geti(D)/gcd(D,3)/6/getk(D)) ;
//cout << endl << "h24 " << nearInt(real(h24)) ;
//cout << endl << nearInt(real(J(Complex(0,sqrt(Fint(D)))))) ;
    if( D%8==2 || D%8==6 ) h24=-h24 ;
    j=power(h24-16,3)/h24 ;
  }

//j=R*R*R ;
//j=5*5*5*power(R,12)*power(1+2*R,3)*power(2-3*R,3) ;


}
#endif

#if 0
void calf2(Complex& R,unsigned long D,Complex& j)
{
//  J=R; return ;
  Complex h24;

cout << endl << "D " << D ;
    h24=power(R,24/gcd(D,3)/getk(D)) ;
    h24*=power(Mint(2),24*geti(D)/gcd(D,3)/6/getk(D)) ;
cout << endl << "h24 " << nearInt(real(h24)) ;
//    h24=power(Mint(2),12)*exp(Complex(0,-2*pi()/48*24))/h24 ;
    h24=-power(Mint(2),12)/h24 ;
    j=power(h24+16,3)/h24 ;

cout << endl << "J " << nearInt(real(J(Complex(Fint(-1),sqrt(Fint(D)) )/2 ))) ;
cout << endl << "j " << j ;

}
#endif


#if 0
void calJ(Complex& R,unsigned long D,Complex& j)
{
    unsigned long d=isDisc(D) ;

    Complex h24 ;
    if( D%3!=0 && D%8!=3 ) {


      if( (D&3)==0 ) {
        D>>=2 ;
        h24=power(R,24/gcd(D,3)/getk(D)) ;
        h24*=power(Mint(2),24*geti(D)/gcd(D,3)/6/getk(D)) ;
//cout << endl << "h24 " << nearInt(real(h24)) ;
//cout << endl << nearInt(real(J(Complex(0,sqrt(Fint(D)))))) ;
        if( D%8==2 || D%8==6 ) h24=-h24 ;
        j=power(h24-16,3)/h24 ;
      }
      else {
        h24=power(R,24/gcd(D,3)/getk(D)) ;
        h24*=power(Mint(2),24*geti(D)/gcd(D,3)/6/getk(D)) ;
cout << endl << "h24 " << nearInt(real(h24)) ;
//    h24=power(Mint(2),12)*exp(Complex(0,-2*pi()/48*24))/h24 ;
        h24=-power(Mint(2),12)/h24 ;
        j=power(h24+16,3)/h24 ;
      }
    }
    else if( D%8==3 && D%6!=3  ) {

      h24=power(R,24/gcd(D,3)/getk(D)) ;
      h24*=power(Mint(2),24*geti(D)/gcd(D,3)/6/getk(D)) ;
cout << endl << "h24 " << nearInt(real(h24)) ;
//    h24=power(Mint(2),12)*exp(Complex(0,-2*pi()/48*24))/h24 ;
      h24=-power(Mint(2),12)/h24 ;
      j=power(h24+16,3)/h24 ;
    }
    else if( D%6==3 ) {

      j=R;
    }
    else {
      if( D%3!=0 ) j=power(R,3) ;
      else  j=R;
    }

}

#endif


#if 0
int jj ;
int main(void)
{
SetPrecision(100) ;
  unsigned long D ;
  unsigned long d ;
  unsigned long h1,h2 ;
  CPUTime cpu1,cpu2 ;
  Complex tau ;
  SetPrecision(100) ;
  double suma ;
  unsigned long prec ;
  PolyM Pm,Qm ;


  D=1 ;
//  for( D=292; D <293 ; D++ ) {
//  for( D=22; D <24 ; D++ ) {
  cin >> D ;
  PolyM Hm ;
  PolyC Pc ;
  Complex J ;
  for(; D<200000 ; D++ ) {
    if( !isNegDisc(D) ) continue ;
//  h1=hDsum(D,0,suma) ;
//  prec=suma*M_PI*sqrt(double(D))/9.6+50 ;
//  SetPrecision(prec) ;

cout << endl << "D " << D ;
    cpu1.Start() ;
    d=D ;

    HilbertPolynomial(D,Hm) ;

    Weber(D,Pm) ;
cout << endl << Pm ;
//cout << endl << Hm ;

    Pc=Complex(Fint(Pm[deg(Pm)]),0) ;
    for( jj=deg(Pm)-1 ; jj>=0 ; jj-- ) {
      Pc<<=1 ;
      Pc+=Complex(Fint(Pm[jj]),0)  ;
    }
    while( !root.empty() ) root.pop_back() ;
    Root(Pc,root) ;

    calJ(root[0],D,J) ;



#if 0
    d=isDisc(D) ;

    if( D%3!=0 && D%8!=3 ) {


      if( (D&3)==0 ) {
        calf(root[0],d,J) ;
      }
      else {
        calf2(root[0],d,J) ;
      }
    }
#if 0
    else if( index_s(d)!=0 ) {
    }
#endif
    else if( D%8==3 && D%6!=3  ) {
#if 1
      calf2(root[0],d,J) ;
#else
      J=power(root[0],3) ;
#endif
    }
    else if( D%6==3 ) {
#if 0
      calf(root[0],D,J) ;
//      J=power(root[0],3) ;
#else

      J=root[0];
#endif
    }
    else {
      if( D%3!=0 ) J=power(root[0],3) ;
      else  J=root[0];
    }
#endif
    cout << endl << "J " << nearInt(real(J)) ;
    cout << endl << "Hm(J) " << nearInt(real(Hm(J)))
         << " " <<  nearInt(imag(Hm(J)));
    if( nearInt(real(Hm(J)))!=0 ) Error( why) ;
//    Hilb2(D,Pm) ;
//  cout << endl << "Hilb2 " << Pm ;
cout << endl << "######################################";
continue ;
    break ;
//    return ;
//



cout << endl << "######################################";
cout << endl << D << " " << h1 << " " << prec << flush  ;
    cpu1.Stop() ;
    cpu2.Start() ;
//  hD1(D) ;
    cpu2.Stop() ;
//  WP(D) ;



//    Weber(d,Pm) ;
//    Hilb4(4*d,Pm) ;
//    WP_new1(d,Pm) ;
//    WP_new(d,Pm) ;
//      Hilb(d,Pm) ;
//Hilb2(D,Pm) ;
//    Pm[0]=1 ;
//    Hilb2(D,Pm) ;
//    Pm[2]=155 ;
//    Pm[1]=650 ;
//    Pm[0]=23375 ;

//    WP_new(D,Pm) ;
//Hilb2(D,Pm) ;
//    Pm[1]=-1575 ;
//    Pm[0]=-218295 ;
//Pm=P ;

cout << endl << Pm ;
cout << endl << Hm ;
//cout << endl << D << " " << h1 << " " << prec << flush  ;
//    WP_new1(D,Pm) ;
//cout << endl << Pm ;

#if 1
    Pc=Complex(Fint(Pm[deg(Pm)]),0) ;
    for( jj=deg(Pm)-1 ; jj>=0 ; jj-- ) {
      Pc<<=1 ;
      Pc+=Complex(Fint(Pm[jj]),0)  ;
    }
#endif
    while( !root.empty() ) root.pop_back() ;
    Root(Pc,root) ;
cout << endl << "calf " << flush ;
//    cout << endl << "Hm(J)" << Pc(root[0]) ;
//break ;
//cout << endl << "J " << J ;

    if( (D&3)==0 ) {
      calf(root[0],d,J) ;
    }
    else {
      if( D%6!=3 ) calf2(root[0],d,J) ;
      else  calf(root[0],d,J) ;
//    J=power(root[0],3) ;
    }
    cout << endl << "J " << nearInt(real(J)) ;
    cout << endl << "Hm(J) " << nearInt(real(Hm(J)))
         << " " <<  nearInt(imag(Hm(J)));
//    cout << endl << real(Hm(J)) ;
  cout << endl << "d D " << d << " " << D ;

#if 0
  Hilb2(d,Pm) ;
    Pc=Complex(Fint(Pm[deg(Pm)]),0) ;
    for( jj=deg(Pm)-1 ; jj>=0 ; jj-- ) {
      Pc<<=1 ;
      Pc+=Complex(Fint(Pm[jj]),0)  ;
    }
    while( !root.empty() ) root.pop_back() ;
    Root(Pc,root) ;
    J=power(root[0],3) ;
cout << endl << "J " << nearInt(real(J)) ;
  cout << endl << "Hm(J) " << nearInt(real(Hm(J))) <<" " <<nearInt(imag(Hm(J))) ;
  cout << endl << Pm ;
  cout << endl << "d D " << d << " " << D ;
#endif
break ;
  if( index_s(d)!=0 ) {
    Hilbs(d,Pm) ;
    cout << endl << Pm ;
    cout << endl << "s " << index_s(d) ;
  }
//cout << endl << "Pc " << Pc(J) ;

break ;
  }
  cout << endl << cpu1 << " " << cpu2 ;
  return 0 ;
}

#endif