//
//	Copyright (C) 1993 by S.Tomabechi
//	All rights reserved.
//
//	computes the integer part of square root for given n
//	by Newton-Raphson method.
//	  m^2 <= n < (m+1)^2
//
#include "Mint.hpp"
#include "Fint.hpp"
#include "Error.hpp"
Mint isqrt(const Mint& n)
{
  if( sign(n)<0 ) Error(negative integer) ;

  long l=len(n) ;

  if( l==0 ) return 0 ;  // add case n=0  1993.08.13

  Mint x(1) ;
  Mint y ;

  l=((l+1)>>1)+1 ;
  x<<=l ;

  for(;;) {
	y=((x+n/x)>>1) ;  //	y=(x+n/x)/2 ;
	if( y<x ) Swap(x,y) ;	 // x <- y
	else return x ;
  }

}
