//
//	PPMPQS Ver 2.4
//
//	Copyright (C) by S.Tomabechi 1995,1996,1997,1998
//	All rights reserved.
//
//	 factor number by PPMPQS
//
//	1995/03/07
//	  MPQS@ ( Multiple Polynomial Quadratic Sieve Method )
//	  ^悯΁A^̈ЂƂĕԂD
//
//	  ȑf, prmdiv gĂ炩ߏĂ
//
//	  D܂Ƃł͂Ȃ֐Ăяo, {p^œnׂ
//	  ϐO|oȕϐɂăp^nȂĂD
//
//	1995/06/26,1995/11/03
//	  f@Ƃ镽߂֐Ɍ肪AӂĂȂ
//	  .
//
//	1996/09/18	32rbgo[WɕύX
//
//	1996/11/25	PPMPQS@o[WɕύX
//
//	1996/12/20	intelligent Gaussian method 
//
//	1997/02/15	ꂽf[^œf[^΍폜悤ɂ.
//				sȂƁA70ȏł͎Ȋ֌WȂƂ
//				D
//
//				fp⿂ɂ悤ɂ.(ʂ̂قǂ͕Ȃ)
//
//	1997/03/15 ӂ邤ۂɎgpƗ̈q[vɂƂĂA
//			   static ̈ɕύX. cache ̃qbg邽߁D
//			   ܂΁A2,3  ɂȂ. 낢뎎Ȃ
//			   ƂʂD
//
//	1997/04/26 intelligent Gaussian elimination ̕
//			   matrix ̑傫Ɉkł悤
//			   5% 炢ȑO舳k邪A܂ʂ͂ȂƂƂ납D
//
//	1997/07/19
//			    f[^  }[W ʂt@CɏłD
//			   ̌CD
//
//	1997/08/06
//			   f[^}[WہAłɃRrl[Vt@C
//			   Ăf[^폜悤ƂĂD
//
//	1997/08/30
//			   (p)^ (pp)^ (f)^ ߂ہA܂蕡Gȑg
//			   Ȃ悤ɂD
//
//	1997/09/18 (p)^ (pp)^ (f)^߂ہAKvȌ (f)^
//			   Ȃꍇɂ́ǍʂjĂɏ\f[^
//			   W߂悤ɕύXDȑÓA̎_œꂽԌʂ
//			   t@CɏoĂD
//
//	1998/10/19 reduced matrix 쐬镔AB
//			   reduced matrix ɂ Gaussian elimination Ń
//			   g߂Ă̂CB
//
#include "Mint.hpp"
#include "Fint.hpp"
#include "LBit.hpp"
#include <math.h>

#include <fstream.h>
#include <io.h>
#include "Error.hpp"

#ifdef _MEMMAN
#  include "MemMan.hpp"
   MemMan Mem ;
#endif

#ifdef __BORLANDC__
#  include <constrea.h>
#  include <conio.h>
#  pragma option -Jg
#else
   int wherex(void) ;
   int wherey(void) ;
   void clrscr(void) ;
   void gotoxy(int x,int y) ;
#  include <memory.h>
#  include <stdlib.h>
#endif

typedef long LONG2[2] ;
typedef long LONG3[3] ;
typedef unsigned short USHORT3[3] ;
typedef unsigned long UL2[2] ;


#define MaxPrimes (50000)
#define MatrixDim (MaxPrimes+33)
#define MaxSieveResult	(512)
#define MaxSearchLoop	 32
#define MaxCycle		 256	   // (f)^𐶐(pp)^̑g̍ő吔

  // ̒l CPUĂ cache ̑傫ɂĈقȂ
  // 256K cache  Pentium ł͂̒lœK
  // 512K cache ł 2-4 {KƎv
//#define MaxSieveUnit (0x00008000UL)
#define MaxSieveUnit (0x00060000UL)

extern const unsigned long SieveUnit=MaxSieveUnit ; // 4 ̔{ɂƂ邱

  // ̒l͂ǂ̂悤Ȓlł悢召֌W͕ۂ
const unsigned short isActive=10 ;
const unsigned short isPivot=7 ;
const unsigned short notActive=5 ;
const unsigned short isDeleted=0 ;
extern const long _Kr_tab[] ;

  // ȉ̐ÓIϐ̐錾͕̏ύXȂ.
  // LbVqbglĕׂĂ.
Mint _fx ;
Mint _a ;
Mint _b ;
long _DivResult ;
long _nResult ;
char logP[MaxPrimes] ;
char SieveArray[MaxSieveUnit] ;
long SievePos[3*MatrixDim] ;
unsigned long _A[10] ;
unsigned long _B[10] ;
unsigned long _FX[10] ;
unsigned long _OFF ;
unsigned long Primes[MaxPrimes] ;
unsigned long nSieveResult=MaxSieveResult ;
							   // 傫ȂȐɂẮAȂɂ
							   // 邱ƂȂȂ̂łŏ\Ȃ͂
unsigned long SieveResult[MaxSieveResult] ;
unsigned long Upper0 ;
unsigned long Upper1 ;
unsigned long Pmax2[2] ;

char Cutoff ;
unsigned long SieveWidth ;
unsigned long SieveWidth2 ;

unsigned long lbyte ;

unsigned long nPrimes ;
unsigned long mPrimes ;
unsigned long v2[(2*MaxPrimes+33+31)/32] ;
long _Kr_tab3[]={0,-1,1} ;		  //  -(n/3)  ]̃}CiX

static Mint y ;
Mint& pp=y ;
#ifdef __BORLANDC__
constream con ;
#endif


void QSortL2A(const long size,const long length,
			  const long pos,const long pos2,long* record) ;
void QSortUSD(const long size,const long length,
			  const long pos,unsigned short* record) ;
static long MergeDuplicatedData(long nF) ;
bool BitDecomp(long nPrimes,Mint& T) ;

void DivideByBase(void) ;

int PrimeDecomp(long nPrimes,unsigned long* Primes,
				unsigned long* index,Mint& q) ;
void Gauss(iostream& mpqsmat,unsigned long** M,long mRow,
		   long nRow,long nCol,long size) ;
void Gauss(unsigned long** M,long nRow,long nCol,long size,unsigned long* ipiv) ;
void SieveInit(unsigned long nPrimes,unsigned long nPrimes2) ;
void Sieve(void) ;
void SetMatrix(fstream& mpqsfx,unsigned long* ifx,long nX,long nF,
			   long nPrimes,
			   USHORT3* row,USHORT3* col,
			   unsigned short** mat) ;
void SGauss(long maxrow,long maxcol,USHORT3* row,USHORT3* col,
			unsigned short** mat,long& nrow,long& ncol,
			long& used_fx,unsigned short*& oldrow) ;



				  // ꎞt@C
static char fxfile[]=".\\MPQSFX.MPQ" ;
static fstream mpqsfx ;

static char ixfile[]=".\\MPQSFXIX.MPQ" ;
static fstream mpqsfxix ;

static char matfile[]=".\\MPQSMAT.MPQ" ;
static fstream mpqsmat ;

static char combfile[]=".\\MPQSCOMB.MPQ" ;
static fstream mpqscomb ;

static char ppfxfile[]=".\\MPQSPPFX.MPQ" ;
static fstream mpqsppfx ;

static char pairfile[]=".\\MPQSPAIR.MPQ" ;
static fstream mpqspair ;

static char pppfile[]=".\\MPQSPPP.MPQ" ;
static fstream mpqsppp ;

static char posfile[]=".\\MPQSPOS.MPQ" ;
static fstream mpqspos ;


/**
static char sqrtfile[]=".\\MPQSSQRT.MPQ" ;
static fstream mpqssqrt ;
**/

static char pivfile[]=".\\MPQSPIV.MPQ" ;
static fstream pivot ;

static char elemfile[]=".\\MPQSELEM.MPQ" ;
static fstream elem ;

static char ansfile[]=".\\MPQSANS.MPS" ;
static fstream mpqsans ;

//
// t@C\
//
//	mpqsfx	 : (f)^f[^
//			   񎟊֐lA
//
//	mpqsfxix : mpqsfx ւ̃CfbNX
//			   t@C|C^				(4 oCg)
//
//	mpqsppfx : (p)^A(pp)^f[^
//			   ꂸɎc p1,p2 ( 4 oCg)
//				񎟊֐lA
//
//	mpqsppp	 : mpqsppfx ւ̃CfbNX
//			   ꂸɎc p1,p2	 ( 4 oCg)
//			   mpqsppfx ւ̃t@C|C^ ( 4 oCg)
//			   (p1,p2) mpqsppfx ֓ǂ݂ɍŝ
//			   ʓ|Ȃ̂Ń_uĎĂ.
//			    ̂Ƃ mpqsppfx ւ̃|C^
//			    ̂Ƃ mpqspair ւ̃|C^
//
//	mpqspair : (p)^A(pp)^ ꂽ֌W
//			   ɂȂ̃f[^ւ̃t@C|C^ (4oCg*2)
//			   񎟊֐lA͏ĂȂD
//
//	mpqssqrt : x^2=p mod N ̍	 ݎgp
//

Mint Upper2 ;


Mint _t ;
static Mint pN ;
static Mint sq ;
static TBit V ;
int nLoop_rho ;
unsigned long _nPrimes ;
unsigned long _mPrimes ;
unsigned long _mPrimes2 ;
unsigned long _lPrimes ;
unsigned long _p1,_p2 ;
static long LargePrime(long needF,long& nLPP) ;



long npp[10] ;
int	 posy ;
Mint const2(2) ;
Mint PPMPQS(const Mint& N)
{

  long nF(0) ;

long nLPP[3]={0,0,0} ;
memset(npp,'\0',10*sizeof(long)) ;

  long j,k ;
  long l ;
  bool found(false) ;
  double f,fMax ;
  unsigned long p,q,pX,pMax ;
  unsigned long mPrimes2(0) ;
  unsigned long lPrimes ;
#ifdef __BORLANDC__
  con.window(1,1,80,45) ;
  con.clrscr() ;
#else
  clrscr() ;
#endif
#ifdef __BORLANDC__
  long nX=min(MaxPrimes,
			  int(	1.78
					*expl(
					   sqrtl(
						 logl((long double)N)
						 *logl(logl((long double)N))
						 /12
						)
					 )
				 ) /32*32
			 ) ;

#else
  long nX ;
  nX=int( 1.78
		   *expl(
			   sqrtl(
				  logl((long double)N)
				  *logl(logl((long double)N))
				  /12
				)
			)
		)/32*32;
  if( nX>MaxPrimes ) nX=MaxPrimes ;
#endif

  nX=nX<56 ? 56:nX ;

  _nPrimes=nX-32 ;

  cout << endl << "PPMPQS    " << N ;

  long mRow(0) ;
  long size=_nPrimes+nX ;


  Primes[0]=-1 ;	// -1  2 ͕K܂߂
  Primes[1]=2 ;

  logP[0]=0 ;

  // fȂ悤 N->pN multiplier ߂
  p=1 ; pX=p ; fMax=0.0 ;
  pMax=(ilog2(N)+1)/3 ;
  if( pMax>40 ) pMax=40 ;
	  // multiplier 傫Ȃƌオꂵ̂ 40 ȉɐ
  for(;;) {

	for(;;) {
	  pN=p*N ;
	  if( (((unsigned long)pN)&7)==1 ) break ; // mod 8
	  else p=nextprm(p) ;
	}

	f=2*log(2)-log(p)/2 ;
	q=2 ;
	for( j=2 ; j<_nPrimes ; j++ ) {
	  do {
		q=nextprm(q)  ;
	  } while( Kronecker(pN%long(q),long(q))<0 ) ;
	  f+=(Kronecker(pN%long(q),long(q))+1)*log(q)/q ;
	}
	if( f>fMax ) { fMax=f ; pX=p ; }
	if( p<pMax ) p=nextprm(p) ;
	else break ;
  }


  pN=pX*N ;			 // N  px*N ɒu

	 // factor base ߂
	 // pN  mod q ̕]ƂȂf q I
  p=2 ;
  for( j=2 ; j<=_nPrimes-1 ; j++ ) {
	for( ;;) {
	  q=nextprm(p) ;
	  if( Kronecker(pN%long(q),long(q))==-1 ){	// ] ?
		p=q ;									// ]łȂ
		continue ;
	  }
	  else break ;								// ]ł
	}
	Primes[j]=q ;
	p=q ;
  }
  Upper0=p ;

  long double lnpN=logl((long double)pN) ;
  SieveWidth=40000*expl(0.66*logl(lnpN)) ;
  if( ilog2(N)<224 ) k=4 ;
  else k=2 ;
  SieveWidth=2*(SieveWidth/SieveUnit/2+k-1)*SieveUnit/k ;
  SieveWidth2=SieveWidth<<1 ;

  double MeanValue=log(double(SieveWidth)*SieveWidth*((long double)pN)/2) ;
  double Scale=2.0*255/MeanValue ;

  long Pmax=Upper0 ;
  long PPmax=isqrt(Pmax) ;
  if( PPmax<65536 ) PPmax=65536 ;
  long PPPmax=isqrt(PPmax) ;
  if( PPPmax<100 ) PPPmax=100 ;

  double Success ;
  if( ilog2(pN)>256 ) Success=0.229000-0.00076*lnpN ;
  else Success=0.15600-0.00036*lnpN ;

  Mint x,w ;

  x=Mint(Pmax)*Pmax ;
  Pmax2[0]=x.digit[0] ;
  Pmax2[1]=x.digit[1] ;
  Cutoff=(0.7075+0.0108*logl((long double)N))*log(Pmax)*Scale ;
  if( ilog2(pN)>256 ) Upper1=Pmax*(1.28+0.45*lnpN) ;
  else Upper1=Pmax*(1.28+0.40*lnpN) ;

  if( Upper1<Pmax ) Upper1=Pmax ;
  Upper2=Int(exp(1.78*Fint(logl(Upper1)))) ;
  if( Upper2<Upper1 ) Upper2=Upper1 ;
  nLoop_rho=isqrt(Upper1)/100 ;

  cout << endl << "#FactorBase " << _nPrimes ;
  cout << " max FactorBase " << p ;
  cout << endl << "max LargePrime < " << Upper1 ;
  cout << ", Upper Bound " << Upper2 ;
  cout << endl << "SieveWidth " << SieveWidth  ;
  cout << ", SieveUnit " << SieveUnit ;
  cout << ", CutOff " << (int)Cutoff ;
  cout << ", multiplier " << pX ;

  // ] x*x=pN mod q ߂
  SievePos[3]=1 ;
  for( j=2 ; j<_nPrimes ; j++ ) {
	q=Primes[j] ;
	if( q==pX  ) SievePos[3*j]=0 ;		   // pX  multiplier
	else SievePos[3*j]=sqrt(pN,q) ;
  }

  for( j=1 ; j<_nPrimes ; j++ ) {
	q = Primes[j] ;
	if( q==pX ) logP[j]=Scale*log(double(q))/2 ;
	else logP[j]=Scale*log(double(q)) ;
  }

  lPrimes=mPrimes=_nPrimes ;
  if( ilog2(pN)>256 ) {					 // fpӂ邤
	for( j=2 ; j<_nPrimes ; j++ ) {
	  q=Primes[j] ;
	  if( q>PPPmax ) break ;
	  if( q==pX ) continue ; // multiplier
	  p=q ;
	  _p1=p ;
	  p*=q ;
	  f=Scale*log(double(p)) ;
	  _p2=sqrt(pN,(const long)q) ;
	  while( p<PPmax ) {
		x=(pN-_p2*Mint(_p2))/_p1 ;
		_p2=mod(_p2+x*invmodp(2*_p2,q)*_p1,p) ;
		f=Scale*log(double(p))-f ;
		if( f<1.0 ) continue  ;
		logP[mPrimes]=(char)f ;
		SievePos[3*mPrimes]=_p2 ;
		Primes[mPrimes]=p ;
		mPrimes++ ;
		_p1=p ; p*=q ;
	  }

	}

	lPrimes=mPrimes ;

	q=2 ;
	p=q ;
	_p1=p ;
	p*=q ;
	f=Scale*log(double(p)) ;

	_p2=1 ;
	while( p<PPmax ) {
	  for( j=0 ; j<2 ; j++ ) {
		_p1=p ;
		p*=q ;
		_p2=mod((pN-_p2*Mint(_p2))/_p1,q) ;
		_p2 += _p2*_p1 ;
	  }
	  f=Scale*log(double(p))-f ;
	  if( f<1.0 ) continue	;
	  logP[lPrimes]=f ;
	  SievePos[3*lPrimes]=_p2 ;
	  Primes[lPrimes]=p ;
	  lPrimes++ ;
	}
//cout << " mPrimes " << mPrimes ;
  }

  mPrimes2=lPrimes-mPrimes ;
  _mPrimes=mPrimes ;
  _mPrimes2=mPrimes2 ;
  _lPrimes=lPrimes ;

				   // t@Cɏo

  // |Nt@CJ
  mpqsfx.open(fxfile,ios::binary|ios::out|ios::in) ;
  if( mpqsfx.bad() ) {
	cerr << endl << "Error : could not open file " << fxfile ;
	Error(file not found) ;
  }

  mpqsfxix.open(ixfile,ios::binary|ios::out|ios::in) ;
  if( mpqsfxix.bad() ) {
	cerr << endl << "Error : could not open file " << ixfile ;
	Error(file not found) ;
  }

  mpqsppfx.open(ppfxfile,ios::binary|ios::in|ios::out) ;
  if( mpqsppfx.bad() ) {
	cerr << endl << "Error : could not open file " << ppfxfile ;
	Error(file not found) ;
  }

  mpqspair.open(pairfile,ios::binary|ios::in|ios::out) ;
  if( mpqspair.bad() ) {
	cerr << endl << "Error : could not open file " << pairfile ;
	Error(file not found) ;
  }
  mpqspair.seekp(8) ;

  mpqsppp.open(pppfile,ios::binary|ios::in|ios::out) ;
  if( mpqsppp.bad() ) {
	cerr << endl << "Error : could not open file " << pppfile ;
	Error(file not found) ;
  }
  mpqspos.open(posfile,ios::binary|ios::out) ;
  if( mpqspos.bad() ) {
	cerr << endl << "Error : could not open file " << posfile ;
	Error(file not found) ;
  }
  mpqspos.write((char*)SievePos,3*lPrimes*sizeof(long)) ;
  mpqspos.close() ;


  Mint d=Int(sqrt(sqrt(Fint(pN))/SieveWidth*738/1000)) ;
  if( d<(unsigned long)Pmax+3 ) d=(unsigned long)Pmax+3 ;
  d=(d/4)*4+3 ;			 // d=3 mod 4 ̒lɂ

  long kLPP(0),lLPP(0),mLPP(0) ;

  Mint c,a2,d2 ;
  long newFF(0) ;
  Mint const3(3) ;

  cout << endl ;
#ifdef __BORLANDC__
  posy=con.rdbuf()->wherey() ;
#else
  posy=wherey() ;
#endif

  // ̒l͖ӖȒlAPɃt@C|C^̒l 0 łȂ邾
  mpqsppfx.write((char*)&_p1,sizeof(_p1)) ;
  mpqsppfx.write((char*)&_p2,sizeof(_p2)) ;
  write(mpqsppfx,_fx) ;
  write(mpqsppfx,sq) ;


  for(;;) {			 // \ȃf|^܂Ń|v

					 // 񎟑  a*x^2+b*x+c
					 // d=3 mod 4 (pN/d)=1 őf炵
					 // d  Euler's criterion 𖞂̂I
	d+=4UL ;
					 // ȑfŊ؂͎̂̂Ă
					 // 111546435=3*5*7*11*13*17*19*23
	if( gcd(d.isRemUL(111546435UL),111546435UL)!=1 ) continue ;

	if( Kronecker(pN,d)!=1 ) continue ;	 // pN ͕]łȂ

	_fx.isShiftr(w.isSubUL(d,1),1) ;	 //	 _fx=(d-1)/2

					//	2^((d-1)/2) mod d = (2/d) ?
	if( long(_a.apower(const2,_fx,d))!=_Kr_tab[((unsigned long)d)&7] )
		continue ;
					//	3^((d-1)/2) mod d = (3/d) ?
					// d=3 mod 4 Ȃ̂ (3/d)=-(d/3)=-(d%3/3) 𗘗p
	if( long(_a.apower(const3,_fx,d))!=_Kr_tab3[d%3] ) continue ;

			// ̕͏ł悢̂ private ֐gp
	_a.power(pN,w.isSubUL(d,3)>>=2,d) ;		 // pow(pN,(d-3)/4,d) ;
	_b.isRem(Mint::_Mtemp.isMul(pN,_a),d) ;
	c.isRem((((pN-_b*_b)/d)*_a*(d+1))>>=1,d) ;
	_a.isMul(d,d) ;
	a2.isShiftl(_a,1) ;
	d2.isShiftl(d,1) ;
	d2.isInvModp(d2,pN) ;
//if( d2==0 ) Error(d2=0) ;
	_b.isRem((Mint::_Mtemp.isMul(c,d)).isAdd(Mint::_Mtemp,_b),_a) ;
	if( (((unsigned long)_b)&1)==0 ) { (_b.isSub(_b,_a)).nDim&=_POSITIVE_ ; }
							   // b is even
	w.isShiftl(_a,2) ;
	divide(Mint::_Mtemp.isSub(Mint::_Mtemp.isMul(_b,_b),pN),w,c,y) ;
	if( !y.isZero() ) continue ;
/********************
	_b=power(pN,(d+1)/4,d) ;
	c=invmodp(2*_b,d) ;
	c *= (pN-_b*_b) ;
	if( c%d!=0 ) continue ;
	c /= d ;
	_a=d*d ;
	_b=mod(_b+c*d,_a) ;
	if( (((unsigned long)b)&1)==0 ) b=a-b ;
	a2=2*a ;
	d2=invmodp(2*d,pN) ;
	c=(_b*_b-pN)/(4*_a) ;
***************/

	y=-_b/a2-SieveWidth ;

	Sieve() ;							// ӂ邢ɂ
										// _nResult ⿂Ɏc
	for( ; _nResult>0 ;	 )	{			// ۂɊĂ݂

	  _OFF=SieveResult[--_nResult] ;
	  x.isAddUL(y,_OFF) ;				// x=y+_OFF

	  ((_fx.isMul(_a,x)+=_b)*=x)+=c ;	// _fx=(_a*x+_b)*x+c ;
										// 񎟑vZ
	  if( _fx.isZero() ) continue ;

	  DivideByBase() ;		 // ۂɊĂ݂ _fx  global ϐœn

	  if( _DivResult<0 ) continue ;
							 // ̏ꍇƂ
							 // ؂ꂸ (p)^ (pp)^Ȃ
nLPP[_DivResult]++ ;
	  found=true ;
		  // 񎟑vZ
	  ((sq.isMul(a2,x)+=_b)*=d2)&=pN ; // sq=mod((a2*x+_b)*d2,pN) ;
	  if ( _DivResult==0 ) {		   // ؂ꂽ (f) ^
		l=mpqsfx.tellp() ;
		mpqsfxix.write((char*)&l,sizeof(l)) ;
		write(mpqsfx,_fx) ;
		write(mpqsfx,sq) ;
		nF++ ;
	  }
	  else {			  // large prime (p)^,(pp)^ ̏ꍇ
		l=-mpqsppfx.tellp() ;	  // t@C|C^𕉐ƂĈ !!
		mpqsppp.write((char*)&_p1,sizeof(_p1)) ;
		mpqsppp.write((char*)&_p2,sizeof(_p2)) ;
		mpqsppp.write((char*)&l,sizeof(l));// ,񎟊֐l̃CfbNX

		mpqsppfx.write((char*)&_p1,sizeof(_p1)) ;
		mpqsppfx.write((char*)&_p2,sizeof(_p2)) ;
		write(mpqsppfx,_fx) ;
		write(mpqsppfx,sq) ;
		kLPP++ ;
	  }
	}

	if( found  /* && kLPP>lLPP */ ) {
	  found=false ;
	  if( Success*(kLPP-mLPP)>=1.0 ) {
#ifdef __BORLANDC__
		con.rdbuf()->gotoxy(1,posy) ;
		cout << endl  << nLPP[0] << "("
			 << int(nF+newFF+Success*(kLPP-lLPP)) << ")/" << nX << " ";
#else
		gotoxy(1,posy) ;
		cout << endl  << nLPP[0] << "("
		 << int(nF+newFF+Success*(kLPP-lLPP)) << ")/" << nX << " " << flush;
#endif
		mLPP=kLPP ;
	  }
					 // kLPP : partially factored data ̌
	  if( nF+newFF+Success*(kLPP-lLPP)>nX ) {
//		if( nF+newFF+Success*kLPP>nX ) {
		// ꂸɎcĂf|^C(f)^쐬

		cout << endl <<	 "search cycles "  ;
		lLPP=kLPP-lLPP ;			 // Vɓꂽ PP ̌
									 // (f) ^𐶐
		newFF=LargePrime(nX-nF,kLPP) ;	// newFF :  (f) ^̌
									 // ς̏C
		if( ilog2(pN)>256 ){
		  Success*=2.0 ;
		  while( Success>0.5) Success*=0.9 ;
		}
		lLPP=kLPP ;					 // ܂ paring ꂸɎcĂ
		mLPP=kLPP ;
		if( newFF>0 ) {
		  nF=MergeDuplicatedData(nF+newFF) ;
		  newFF=0 ;
		}
		else newFF=-newFF ;
		if( nF>nX ) break ;						  // \f|^
		else {
		  cout << endl << nF << " data gained. " ;
		  cout << endl << " Try more because of not enough data." ;
		  mpqspos.open(posfile,ios::binary|ios::in) ;
		  mpqspos.read((char*)SievePos,3*lPrimes*sizeof(long)) ;
		  mpqspos.close() ;

		}
	  }
	}
  }
  posy++ ;
//con.rdbuf()->gotoxy(1,posy) ;
  cout << endl << "(f)  type " << nLPP[0] << " total " << nF ;
  posy++ ;
  cout << endl << "(p)  type " << nLPP[1]
	 << "( p_p " << npp[0] << ", p_p_pp " << npp[1]
	 << ", p_p_p_p_pp_pp " << npp[4] << ")" ;
  posy++ ;
  cout << endl << "(pp) type " << nLPP[2]
	 << "( pp_pp " << npp[2] << ", pp_pp_pp " << npp[3] << ")" ;

  mpqsppfx.close() ;
  mpqspair.close() ;
  unlink(pairfile) ;
  mpqsppp.close() ;
  mpqsfxix.close() ;

  if( nX>MaxPrimes ) nX=MaxPrimes ;

		// |C^̔zƂėp
  unsigned long** Mat=(unsigned long**)SievePos ;

  mpqsfx.seekp(0) ;
  USHORT3* row=new USHORT3[nX] ;
  if( !row ) Error(allocate error) ;
  USHORT3* col=new USHORT3[_nPrimes] ;
  if( !col ) Error(allocate error) ;
  V.SetBitString(_nPrimes,v2) ;

			   //(f)^f[^̃t@C|C^
  unsigned long* ifx=(unsigned long*)SievePos+2*MatrixDim ;
  mpqsfxix.open(ixfile,ios::binary|ios::in) ;
  if( mpqsfxix.bad() ) {
	cerr << endl << "Error : could not open file " << ixfile ;
	Error(file not found) ;
  }
  mpqsfxix.read((char*)ifx,nX*sizeof(unsigned long)) ;
  mpqsfxix.close() ;

  SetMatrix(mpqsfx,ifx,nX,nF,_nPrimes,row,col,(unsigned short**)Mat) ;
  mpqsfx.close() ;

  long nrow,ncol ;
  long used_fx ;
  unsigned short* oldrow ;
  posy++ ;
  cout << endl << "structured Gaussian elimination " << flush ;
  SGauss(nX,_nPrimes,row,col,(unsigned short**)Mat,nrow,ncol,
		  used_fx,oldrow) ;

  mpqsfx.open(fxfile,ios::binary|ios::out|ios::in) ;
  if( mpqsfx.bad() ) {
	cerr << endl << "Error : could not open file " << fxfile ;
	Error(file not found) ;
  }

//	lbyte=((ncol+used_fx+31)>>5)<<2 ;
//	lbyte=((ncol+31)>>5)<<2 ;
  long sizer ;
  long lbyter ;
  sizer=ncol ;
//	sizer=nrow ;
  lbyter=((sizer+31)>>5)<<2 ;

  mpqsmat.open(matfile,ios::binary|ios::in) ;
  mpqsmat.seekp(0) ;
  for( j=0 ; j<nrow ; j++ ) {
	Mat[j]=new unsigned long[(lbyter>>2)] ;
	mpqsmat.read((char*)Mat[j],lbyter) ;
//V.SetBitString(sizer,Mat]j]) ;
//cout << endl << V ;
  }

  mpqsmat.close() ;

				// Gauss @,ƂȂg𓾂
  unsigned long* ipiv ;
  ipiv =(unsigned long*)SievePos+2*MatrixDim ;
  cout << endl << "          " << "used memory " << (nrow*lbyter+1023)/1024 << "K" ;
  Gauss(Mat,nrow,ncol,sizer,ipiv) ;
  cout << endl << "end Gaussian elimination" ;
  size=used_fx ;
  lbyte=((size+31)>>5)<<2 ;

  mpqscomb.open(combfile,ios::binary|ios::in) ;
  mpqsans.open(ansfile,ios::binary|ios::out|ios::in) ;
  mpqsans.seekg(0) ;
  TBit W ;
  TBit U ;
  V.SetBitString(size,v2) ;
  long nrel ;
  nrel=nrow-ncol ;
  nrel=(nrel>256 ? 256:nrel) ;			// get at most 256 relations
  unsigned long** ans_ary ;
  ans_ary=(unsigned long**)SieveResult ;
  for( j=0 ; j<nrel ; j++ ) {
	ans_ary[j]=new unsigned long[lbyte>>2] ;
	mpqscomb.seekp(ipiv[j+ncol]*lbyte) ;
	mpqscomb.read((char*)ans_ary[j],lbyte) ;
  }
  for( k=0 ; k<ncol ; k++ ) {
	mpqscomb.seekp(ipiv[k]*lbyte) ;
	mpqscomb.read((char*)v2,lbyte) ;
	for( j=0 ; j<nrel ; j++ ) {
	  U.SetBitString(ncol,Mat[j+ncol]) ;
	  if( U[k] ) {
		W.SetBitString(size,ans_ary[j]) ;
		W^=V ;
	  }
	}
  }

/***************************
  unsigned long* w2 ;
  w2=new unsigned long[lbyte>>2] ;
  W.SetBitString(size,w2) ;
  for( j=ncol ; j<nrow ; j++ ) {
//	  memset(w2,0x00,lbyte) ;
	U.SetBitString(ncol,Mat[j]) ;
	mpqscomb.seekp(ipiv[j]*lbyte) ;
	mpqscomb.read((char*)w2,lbyte) ;
	for( k=0 ; k<ncol ; k++ ) {
	  if( U[k] ) {
		mpqscomb.seekp(ipiv[k]*lbyte) ;
		mpqscomb.read((char*)v2,lbyte) ;
		W^=V ;
	  }
	}
	mpqsans.write((char*)w2,lbyte) ;
  }
  for( j=ncol ; j<nrow ; j++ ) delete [] Mat[j] ;
  delete [] w2 ;
*************************/
  for( j=0 ; j<nrel ; j++ ) {
	delete [] Mat[j+ncol] ;
	mpqsans.write((char*)ans_ary[j],lbyte) ;
	delete [] ans_ary[j] ;
  }
  for( j=ncol+nrel ; j<nrow ; j++ ) delete Mat[j] ;
  mpqscomb.close() ;
  mpqsans.close() ;

  unsigned long* index=(unsigned long*)SievePos ;
  mpqsfxix.open(ixfile,ios::binary|ios::in) ;
  if( mpqsfxix.bad() ) {
	cerr << endl << "Error : could not open file " << ixfile ;
	Error(file not found) ;
  }
  mpqsfxix.read((char*)ifx,nX*sizeof(long)) ;
  mpqsfxix.close() ;

//	mpqsfx.open(fxfile,ios::binary|ios::in) ;
//	if( mpqsfx.bad() ) {
//	  cerr << endl << "Error : could not open file " << fxfile ;
//	  Error(file not found) ;
//	}

  mpqsans.open(ansfile,ios::binary|ios::in) ;
//	mpqsans.seekp(0) ;



  V.SetBitString(used_fx,v2) ;
  lbyte=((used_fx+31)>>5)<<2 ;
#ifdef __BORLANDC__
  posy=con.rdbuf()->wherey() ;
#else
  posy=wherey() ;
#endif
//	  mpqsans.seekp(0) ;
//	for( l=0 ; l<nrel ; l++ ) {
  for( l=ncol ; l<nrow	; l++ ) {

//	  mpqsans.read((char*)V.bit,lbyte) ;
	mpqsans.read((char*)v2,lbyte) ;

	x=1 ;

	for( k=0 ; k<_nPrimes ; k++ ) index[k]=0 ;

	for( k=0 ; k<used_fx ; k++ ) {
	  if( V[k] ) {
		mpqsfx.seekp(ifx[oldrow[k]]) ;
		read(mpqsfx,_fx) ;
		read(mpqsfx,sq) ;
		(x*=sq)%= N	 ;			  // x=mod(x*sq,pN)
		if( _fx<0 ) ~_fx ;		  // {̙pw̒l߂
		if( !PrimeDecomp(_nPrimes-1,Primes+1,index+1,_fx) )
//			goto FAILED ;
		  Error(Prime decomposition error) ;
	  }
	}
	y=1 ;
	for( k=1 ; k<_nPrimes ; k++ ) {
	  p=Primes[k] ;
	  if( index[k]!=0 ) {
		q=index[k]>>1 ;
		y*=power(sq=p,_fx=q,N) ; // *p^q mod N
		y%=N ;
	  }
	}

	d=gcd(x-y,N) ;
	if( d!=1 && d!=N && d!=0 ) goto RET ; // q
FAILED:
	cout << endl << "failed " ;
  }
  d=1 ;									  // s

RET: ;
  mpqsans.close() ;
  mpqsfx.close() ;

  return d ;

}

///////////////////////////////////////////
//
//	df[^̂Ă.
//	ꂽ (f) ^f[^ Ɋւă\[g
//
static long MergeDuplicatedData(long nF)
{
  LONG3* fp=NULL ;
  fp=NULL ;
  long j,k ;
  long fxpos ;

  fp=new LONG3[nF] ;
  if( !fp ) Error(allocate error) ;
  fxpos=mpqsfx.tellp() ;
  mpqsfxix.seekp(0) ;
  for( j=0 ; j<nF ; j++ ) {
	mpqsfxix.read((char*)&(fp[j][2]),sizeof(long)) ;   // t@C|C^
	mpqsfx.seekp(fp[j][2]) ;
	read(mpqsfx,_fx) ;
	fp[j][1]=(unsigned long)_fx ;	// fx ̈ꌅڂL[ɂ
	fp[j][0]=len(_fx) ;				//  2iWJł̒
  }
  QSortL2A(nF,12,0,4,(long*)fp) ;

  for( k=0,j=1 ; j<nF ; j++ ) {		// df[^̂Ă
	if( fp[j-1][1]==fp[j][1] ) {
	  mpqsfx.seekp(fp[j-1][2]) ;
	  read(mpqsfx,_fx) ;
	  if( sign(_fx)<0 ) ~_fx ;
	  mpqsfx.seekp(fp[j][2]) ;
	  read(mpqsfx,_t) ;
	  if( sign(_t)<0 ) ~_t ;
	  if( _fx==_t ) {				// ꌅڂv̂őŜr
		 k++ ;
		 fp[j-1][0]=0 ;				// 폜}[N
	  }
	}
  }
  if( k>0 ) {
posy++ ;
	cout << endl << k << " duplicated data merged " << flush ;
	QSortL2A(nF,12,0,8,(long*)fp) ;
  }

  QSortL2A(nF-k,12,0,8,(long*)fp+3*k) ;	 // sort on length

  mpqsfxix.seekp(0) ;
  for( j=k ; j<nF ; j++ )		 // }[W̌ʁA\[ǧʂo
	mpqsfxix.write((char*)&fp[j][2],sizeof(long)) ;


  if( fp!=NULL ) delete [] fp ;
  mpqsfx.seekp(fxpos) ;
  return( nF-k ) ;

}

///////////////////////////////////////////
//
// (p) ^ (pp)^ (f)^쐬
//
static long LargePrime(long needF,long& nLPP)
{

  LONG3* ppp3 ;
  long* ppp ;
  long j,k,l,l1,l2 ;
  long k0(0),k1 ;
  unsigned long p1,p2 ;
  long newFF(0) ;
  ppp3=new LONG3[nLPP] ;   // ̃͑傫Ȃ̂ŏIɂ͍HvKv ?
  if( !ppp3 ) Error( ppp3 allocate error) ;
  ppp=(long*)ppp3 ;

  long ppfxpos=ppfxpos=mpqsppfx.tellp() ;
  long ppppos=mpqsppp.tellp() ;

  mpqsppp.seekp(0) ;
  mpqsppp.read((char*)ppp,12*nLPP) ;

	 //	 L[ p2 L[ p1 Ń\[g
  QSortL2A(nLPP-k0,12,4,0,ppp+3*k0) ;
  do {
	for( k=0,j=k0+1 ; j<nLPP ; j++ ) {		// df[^̂Ă
	  if( ppp3[j][0]==ppp3[j-1][0] && ppp3[j][1] ==ppp3[j-1][1] ) {

		l1=ppp3[j-1][2] ;
		if( l1<0 ) l1=-l1 ;
		else continue ;		// ̃f[^̓Rrl[Vt@C
							// o^Ă̂ŁA폜łȂD
		l2=ppp3[j][2] ;
		if( l2<0 ) l2=-l2 ;
		else continue ;	   // 

		mpqsppfx.seekp(l1) ;
		mpqsppfx.read((char*)&p1,sizeof(p1)) ;
		mpqsppfx.read((char*)&p1,sizeof(p1)) ;
		read(mpqsppfx,_fx) ;
		if( sign(_fx)<0 ) ~_fx ;

		mpqsppfx.seekp(l2) ;
		mpqsppfx.read((char*)&p1,sizeof(p1)) ;
		mpqsppfx.read((char*)&p1,sizeof(p1)) ;
		read(mpqsppfx,_t) ;
		if( sign(_t)<0 ) ~_t ;

		if( _fx==_t ) {
		  ppp3[j-1][1]=0 ;
		  k++ ;
		}
	  }
	}
	if( k>0 ) {
	  QSortL2A(nLPP-k0,12,4,0,ppp+3*k0) ;
	  k0+=k ;
	  posy++ ;
	}
  } while( k!=0 ) ;
  if( k0>0 ) cout << endl << k0 << " duplicated data merged in Large Prime" ;
  k1=k0 ;

  for( l1=0 ; l1<MaxSearchLoop ; l1++ ) {
	for( j=k0 ; j<nLPP-1 ; j++ ) {
	  if( ppp3[j][1]<=1 ) continue ;	// ł pairing ςł
	  if( ppp3[j+1][1]==ppp3[j][1] ) {	// pairing \

		l=mpqspair.tellp() ;
				   // pair ƂȂg̃CfbNX
		mpqspair.write((char*)(ppp+3*j+2),sizeof(long)) ;
		mpqspair.write((char*)(ppp+3*(j+1)+2),sizeof(long)) ;
		ppp3[j][2]=l ;	 // combination file ɂCfbNX
		ppp3[j][1]=ppp3[j+1][0] ;
		if( ppp3[j][0]==ppp3[j][1] ) ppp3[j][1]=1 ;
	  }
	}

	QSortL2A(nLPP-k0,12,4,0,ppp+3*k0) ;

	if( ppp3[k0][1]!=1 ) break ;		// ͂V pairing ͌Ȃ
	else {
	  for( j=k0 ; j<nLPP ; j++ ) {

		if( ppp3[j][1]>1 ) { k0=j ; break ; }
	  }
	}

  }

  long pairpos=mpqspair.tellp() ;	   // save file pointer

  int is,ie ;
  long* ifp=(long*)SievePos ;
//	long* ifp=(long*)SieveResult ;
  int pptype ;

  for( j=k1 ; j<k0 ; j++ ) {
	is=ie=0 ;				 // Xgɂ
	if( ppp3[j][2]>0 ) {
	  mpqspair.seekp(ppp3[j][2]) ;	 // combination file ɍs
	  mpqspair.read((char*)&l1,sizeof(l1)) ;
	  mpqspair.read((char*)&l2,sizeof(l2)) ;
	  ifp[ie++]=l1 ;
	  ifp[ie++]=l2 ;
	}
	else ifp[ie++]=ppp3[j][2] ; // combination file ɂ͑Ή鍀͂Ȃ
								// Ƃ͂Ȃ͂.
								// ,p1=p2=1 ^̂̂܂߂Ƃ
								// ꍇ
	for( k=is ; k<ie ; ) {		// œꂽm|hɓWJ
	  if( ifp[k]<=0 ) k++ ;		// ̃m|h́CtD
	  else {					// ̃m|h͎q
		mpqspair.seekp(ifp[k])	;  // qXgɉ
		mpqspair.read((char*)&l1,sizeof(l1)) ;
		mpqspair.read((char*)&l2,sizeof(l2)) ;
		ifp[k]=l1 ;				// ̃m|hׂ͂Ă悢
		ifp[ie++]=l2 ;
	  }
	  if( ie>MaxCycle ) break ;	   // TCN
	}
	if( ie>MaxCycle ) continue ;   // TCN͎̂Ă
	if( --needF<0 ) break ;
	newFF++ ;
  }
  if( needF>0 ) {
	mpqsppfx.seekp(ppfxpos) ;	// reset file pointer
	mpqspair.seekp(pairpos) ;
	mpqsppp.seekp(ppppos) ;
	delete [] ppp3 ;
	return -newFF ;
  }
  else {
	newFF=0 ;
  }


  for( j=k1 ; j<k0 ; j++ ) { // generate f-type from p-type and pp-type
	is=ie=0 ;				 // Xgɂ
	pptype=0 ;
	if( ppp3[j][2]>0 ) {
	  mpqspair.seekp(ppp3[j][2]) ;	 // combination file ɍs
	  mpqspair.read((char*)&l1,sizeof(l1)) ;
	  mpqspair.read((char*)&l2,sizeof(l2)) ;
	  ifp[ie++]=l1 ;
	  ifp[ie++]=l2 ;
	}
	else ifp[ie++]=ppp3[j][2] ; // combination file ɂ͑Ή鍀͂Ȃ
								// Ƃ͂Ȃ͂.
								// ,p1=p2=1 ^̂̂܂߂Ƃ
								// ꍇ
	for( k=is ; k<ie ; ) {		// œꂽm|hɓWJ
	  if( ifp[k]<=0 ) k++ ;		// ̃m|h́CtD
	  else {					// ̃m|h͎q
		mpqspair.seekp(ifp[k])	;  // qXgɉ
		mpqspair.read((char*)&l1,sizeof(l1)) ;
		mpqspair.read((char*)&l2,sizeof(l2)) ;
		ifp[k]=l1 ;				// ̃m|hׂ͂Ă悢
		ifp[ie++]=l2 ;
	  }
	  if( ie>MaxCycle ) break ;	   // TCN
	}
	if( ie>MaxCycle ) continue ;   // TCN͎̂Ă
	pp=1 ;
	_fx=1 ;
	sq=1 ;				 //	 (ss'..)^2*(pp'..)^-2=ff'.../(pp'..) mod pN
						 //	 ̕,𕔕߂
	for( k=0 ; k<ie ; k++ ) {
	  if( ifp[k]>0 ) continue ; // Ԃ񂱂̃`FbN͂ȂĂ悢

	  mpqsppfx.seekp(-ifp[k]) ;
	  mpqsppfx.read((char*)&p1,sizeof(p1)) ;
	  if( p1!=1 ) pptype++ ;
	  pp*=p1 ;				   // large prime ̐ς߂
	  mpqsppfx.read((char*)&p2,sizeof(p2)) ;
	  pp*=p2 ;				   // pp'..
	  read(mpqsppfx,_t) ;	   // 񎟊֐̒l
	  _fx*=_t ;					// ff'..
	  _fx/=p1 ;
	  _fx/=p2 ;
	  read(mpqsppfx,_t) ;		 // 
	  (sq*=_t)%=pN	;		 // ss'..
	}
	if( ie<=0 ) continue ;
	pp=mod(isqrt(pp),pN) ;		   // 
	sq*=invmodp(pp,pN) ;
	sq=mod(sq,pN) ; // pp̋t

	l=mpqsfx.tellp() ;
	mpqsfxix.write((char*)&l,sizeof(l)) ;

	write(mpqsfx,_fx) ;
	write(mpqsfx,sq) ;			 // ʂo

	if( pptype<10 ) npp[pptype]=npp[pptype]+1 ;
	else npp[9]++ ;

	newFF++ ;
  }

  if( k0>0 )  {

	mpqsppp.seekp(0) ;	// ܂ paring łĂȂƂo.
						// Ƃނ,paring łƂ̂Ă.
	mpqsppp.write((char*)(ppp+3*k0),12*(nLPP-k0)) ;

	nLPP-=k0 ;
  }

  mpqsppfx.seekp(ppfxpos) ;	  // reset file pointer
  mpqspair.seekp(pairpos) ;

  delete [] ppp3 ;		// delete heap area

  return newFF ;
}

////////////////////////////////////////
//
// mpqsfx : factored data
// ifx	  : t@C|C^
// nF	  : (f) ^f[^̌
//
void SetMatrix(fstream& mpqsfx,unsigned long* ifx,
			   long nX,long nF,
			   long _nPrimes,
			   USHORT3* row,USHORT3* col,
			   unsigned short** mat)
{
  unsigned short* warray=(unsigned short*)SievePos+2*MatrixDim ;
  long j,k,l,ir ;
  unsigned short* el ;
  Mint fx ;
  for( j=0 ; j<_nPrimes ; j++ ) {
	col[j][2]=isActive ;
	col[j][1]=(unsigned short)j ;		// ԍ
	col[j][0]=0 ;						// column weight
  }

  for( ir=j=0 ; j<nF ; j++ ) {
	mpqsfx.seekp(ifx[j]) ;
	read(mpqsfx,fx) ;
									   // Factor Base ň
	if( !BitDecomp(_nPrimes,fx) ) {
									   // {͂ȂĂ͂Ȃ
	  for( k=0 ; k<_nPrimes ; k++ ) V.BitOff(k) ;
	}
	// ƂĂ
	// ȂȂÔ
	for( l=0,k=0 ; k<_nPrimes ; k++ ) {
	  if( V[k] ) {			  // k bit ڂ on ?
		warray[l++]=(unsigned short)k ;
							  // column weight 𑝂₷
		if( col[k][0]!=0xffff ) col[k][0]++ ;
	  }
	}
	read(mpqsfx,fx) ;
	if( l>0 ) {
	  el=new unsigned short[l] ;
	  if( !el ) Error(allocate error) ;
	  mat[ir]=el ;
	}
	else mat[ir]=NULL ;
	for( k=0 ; k<l ; k++ )
	  el[l-k-1]=warray[k] ;	  // ~ɕׂ
	row[ir][0]=(unsigned short)l ; // bit on ̗vf̌
	row[ir][1]=(unsigned short)j ; // sԍ
	row[ir][2]=isActive ;
	++ir ;
	if( ir>=nX ) break ;	  // \ꂽ ?
  }


					// bit on ̗vft@CɏoD
  elem.open(elemfile,ios::binary|ios::out) ;
  if( elem.bad() ) {
	cerr << endl << "Error : could not open file " << elemfile ;
	Error(file not found) ;
  }
  for( j=0 ; j<nX ; j++ ) {
	elem.write((char*)&row[j][0],2) ;
	if( row[j][0]!=0 ) elem.write((char*)mat[j],2*row[j][0]) ;
  }
  elem.close() ;

//cout << endl << "decomposed " << ir << flush ;
}

///////////////////////////////////////////////////////////
//
//	intelligent Gaussian elimination for sparse matrix
//
void SGauss(long maxrow,long maxcol,USHORT3* row,USHORT3* col,
			unsigned short** mat,long& nrow,long& ncol,
			long& lrow,unsigned short*& oldrow)
{
  long krow,kcol ;
  long j,k,ie ;
  unsigned short l,r ;	 // l,r must be 2byte integer
  unsigned long** bitmat=(unsigned long**)mat ;
  long c,c1,c0 ;
  long lcol,mcol ;
  long n ;
  unsigned short* el ;
  long delc(0) ;
  long npivot(0) ;
  unsigned short* icol=(unsigned short*)SievePos+2*MatrixDim ;
  unsigned short* nowrow=icol ;
  oldrow=icol+MatrixDim ;
  unsigned short* nel=oldrow+MatrixDim ;
  bool* isDefined=(bool*)(nel+MatrixDim) ;

Initial:
  pivot.open(pivfile,ios::binary|ios::out|ios::in) ;
  if( pivot.bad() ) {
	cerr << endl << "Error : could not open file " << pivfile ;
	Error(file not found) ;
  }

  krow=maxrow ;
  kcol=maxcol ;
  QSortUSD(krow,6,0,(unsigned short*)row) ; // sort on row wight

							// s inactive ɂ
Step0:
  QSortUSD(kcol,6,0,(unsigned short*)col) ; // kcol is # of active columns
							// column weight Ɋւč~ɕבւ
  mcol=(kcol+31)>>5 ;		// 1/32  inactive ɂ
							// mcol inactive ɂ̌

  if( col[mcol][0]==0xffff ) {	   // weight  2^16 ȏ
	for( j=mcol ; j<kcol ; j++ ) { // ̂悤ȗ͖ inactive ɂ
	  if( col[j][0]!=0xffff ) {
		mcol=j ;
		break ;
	  }
	}
  }

  for( j=0 ; j<mcol ; j++ ) col[j][2]=notActive ;


Step1:
  if( mcol>0 ) {
	QSortUSD(mcol,6,2,(unsigned short*)col) ;

	for( j=0 ; j<krow ; j++ ) {
	  r=row[j][1] ;			   // sԍ
	  el=mat[r] ;			   // el[0] ͏߂Ɋmۂꂽz̑傫
	  n=0 ;
	  for( l=0,k=0 ; k<mcol ; k++ ) {
		c=col[k][1] ;
		for( ; l<row[j][0] ; l++ ) {
		  if( el[l]==c ) {	   // inactive ɂȂɒlvfO
			el[l]=0 ;
			col[k][0]-- ;
			n++ ;
			l++ ;
			break ;
		  }
		  else if( el[l]>c ) continue ;	 // ܂傫
		  else break ;					 // ȂĂ܂
		}
	  }
	  if( n>0 ) {
		QSortUSD(row[j][0],2,0,el) ;
		row[j][0]-=(unsigned short)n ; // inactive ꂽcolumn 
	  }
	}

										 // inactive ɂȂE֒ǂ
	QSortUSD(kcol,6,4,(unsigned short*)col) ;
	kcol-=mcol ;

	QSortUSD(krow,6,0,(unsigned short*)row) ;
	for( lrow=0,j=krow-1 ; j>=0 ; j-- ) {
	  if( row[j][0]>0 ) { lrow=j+1 ; break ; }
	}
	krow=lrow ;

  }


Step2:
  QSortUSD(kcol,6,0,(unsigned short*)col);
							   // column weight 0,1 ̗T
  for( lcol=0,j=kcol-1 ; j>=0 ; j-- ) {
	if( col[j][0]>0 ) { lcol=j+1 ; break ; }
  }
  for( j=lcol ; j<kcol ; j++ ) {
	if( col[j][2]!=isDeleted ) {
	  col[j][2]=isDeleted ;
	  delc++ ;
	}
  }
  QSortUSD(kcol,6,4,(unsigned short*)col) ;
  kcol=lcol ;
  QSortUSD(kcol,6,0,(unsigned short*)col) ;
  for( lcol=0,j=kcol-1 ; j>=0 ; j-- ) {
	if( col[j][0]>1 ) { lcol=j+1 ; break ; }
  }

  if( lcol==kcol ) goto Step3 ;


  QSortUSD(kcol-lcol,6,2,(unsigned short*)col[lcol]) ;	// ~ɕׂ
  for( j=0 ; j<maxcol ; j++ ) icol[col[j][1]]=(unsigned short)j	  ;
  for( lrow=0,j=0 ; j<krow ; j++ ) {
	r=row[j][1] ;			 // sԍ
	el=mat[r] ;				 // el[0] ͏߂Ɋmۂꂽz̑傫
	for( l=0,k=lcol ; k<kcol ; k++ ) {
	  c=col[k][1] ;
	  for( ; l<row[j][0] ; l++ ) {
		if( el[l]==c ) {	 // ԍT
		  row[j][2]=isDeleted ;
		  for( n=0 ; n<row[j][0] ; n++ ) {
			col[icol[el[n]]][0]-- ;	   // column weight 炷
			el[n]=0 ;				   // 폜
		  }
		  lrow++ ;
		  row[j][0]=0 ;
		  goto NEXT_ROW ;
		}
		else if( el[l]<c ) break ;	   // ȂĂ܂
	  }
	}
NEXT_ROW: ;
  }

  for( j=lcol ; j<kcol ; j++ ) col[j][2]=isDeleted ;  //  폜} [N
  QSortUSD(kcol,6,4,(unsigned short*)col) ; // ̏͏ȂĂ悢
  kcol=lcol ;								// 폜}[N̂̂Ă
  QSortUSD(krow,6,4,(unsigned short*)row) ;
  for( lrow=0, j=krow-1 ; j>=0 ; j-- ) {
	if( row[j][2]>isPivot ) { lrow=j+1 ; break ; }
  }
  krow=lrow ;
  QSortUSD(krow,6,0,(unsigned short*)row) ;	 // sort on row weight
  for( lrow=0, j=krow-1 ; j>=0 ; j-- ) {
	if( row[j][0]>0 ) { lrow=j+1 ; break ; }
  }
  krow=lrow ;

  if( kcol==0 ) goto Step7 ;
  else goto Step2 ;	   // ܂폜ł񂪂邩

Step3:		   // 폜Ԃs폜

  if( delc<1 )	goto Step4 ;
  for( j=0 ; j<maxcol ; j++ ) icol[col[j][1]]=(unsigned short)j	  ;
  QSortUSD(krow,6,0,(unsigned short*)row) ; // row weight Ɋւă\|g
  for( j=0 ; j<delc ; j++ ) {
	el=mat[row[j][1]] ;
	for( k=0 ; k<row[j][0] ; k++ ) {		// Ή̃JEg炷
	  col[icol[el[k]]][0]-- ;
	  el[k]=0 ;
	}
	row[j][0]=0 ;
	row[j][2]=isDeleted ;

  }
  QSortUSD(krow,6,4,(unsigned short*)row) ;	  // 폜s֎Ă
  krow -= delc ;							  // ܂̂Ă
  QSortUSD(krow,6,0,(unsigned short*)row) ;
  delc=0 ;
  goto Step2 ;

Step4:

  for( j=0 ; j<maxcol ; j++ ) icol[col[j][1]]=(unsigned short)j ;
				   // ԍ -> ̃CfbNX

Step41:							  // row-weight 1 ̍s𑼂̍sɉ
  for( lrow=0,j=krow-1 ; j>=0 ; j-- ) {
	if( row[j][0]>1 ) { lrow=j+1 ; break ; }
  }
  for( j=krow-1 ; j>=lrow ; j-- ) {
	if( row[j][0]>1 ) break ;
	if( row[j][0]==0 ) continue ;
	r=row[j][1] ;
	el=mat[r] ;
	row[j][2]=isPivot ;
	c=el[0] ;
	for( k=j-1 ; k>=0 ; k-- ) {
	  el=mat[row[k][1]] ;
	  for( l=0 ; l<row[k][0] ; l++ ) {
		if( el[l]==c ) {			   // column
		  el[l]=0 ;					   // ꂽ
		  col[icol[c]][0]-- ;		   // column weight 炷
		  QSortUSD(row[k][0],2,0,el) ; //
		  row[k][0]-- ;
		  pivot.write((char*)&r,sizeof(r)) ;   // s
		  pivot.write((char*)&(row[k][1]),2) ;	// ꂽs
		  npivot++ ;
		  break ;
		}
		else if( el[l]<c ) break ;
	  }
	}

	el=mat[r] ;
	for( k=0 ; k<row[j][0] ; k++ ) {
	  col[icol[el[k]]][0]-- ;
	  el[k]=0 ;
	}
	row[j][0]=0 ;
	col[icol[c]][2]=isDeleted ;

  }

  if( lrow<krow ) {
	QSortUSD(krow,6,4,(unsigned short*)row) ; // row-weight Ɋւĕבւ
	for( lrow=0,j=krow-1 ; j>=0 ; j-- ) {
	  if( row[j][2]>isPivot ) { lrow=j+1 ; break ; }
	}
	krow=lrow ;
	QSortUSD(krow,6,0,(unsigned short*)row) ; // row-weight Ɋւĕבւ
	for( lrow=0,j=krow-1 ; j>=0 ; j-- ) {
	  if( row[j][0]>0 ) { lrow=j+1 ; break ; }
	}
	krow=lrow ;
	if( krow<=0 ) goto Step7 ;
	if( row[krow-1][0]<=1 ) goto Step41 ;	 // V weight=1 ̍s
  }


Step5:	  // row weight 2 ̍s𑼂̍sɉ

  for( lrow=0,j=krow-1 ; j>=0 ; j-- ) {
	if( row[j][0]>2 ) { lrow=j+1 ; break ; }
  }
  for( j=krow-1 ; j>=lrow ; j-- ) {

	if( row[j][0]>2 ) break ;	   // row weight 1 ̍s폜
	if( row[j][0]!=2 ) continue ;
	r=row[j][1] ;
	el=mat[r] ;

	row[j][2]=isPivot ;
	c1=el[0] ;
	c0=el[1] ;
	for( k=j-1 ; k>=0 ; k-- ) {
	  el=mat[row[k][1]] ;
	  for( l=0 ; l<row[k][0] ; l++ ) {
		if( el[l]==c1 ) {
		  for( n=l+1 ; n<row[k][0] ; n++ ) {
			if( el[n]==c0 ) {
			  el[l]=0 ;
			  el[n]=0 ;
			  col[icol[c1]][0]-- ;
			  col[icol[c0]][0]-- ;
			  QSortUSD(row[k][0],2,0,el) ;
			  row[k][0] -= (unsigned short)2 ;
			  pivot.write((char*)&r,sizeof(r)) ;
			  pivot.write((char*)&(row[k][1]),2) ;
			  npivot++ ;
			  goto NEXT ;
			}
			else if( el[n]<c0 ) break ;
		  }
		  el[l]=(unsigned short)c0 ;
		  col[icol[c1]][0]-- ;		// column wight 炷
		  col[icol[c0]][0]++ ;
		  QSortUSD(row[k][0],2,0,el) ;
		  pivot.write((char*)&r,sizeof(r)) ;	 // pivot sL^
		  pivot.write((char*)&(row[k][1]),2) ;
		  npivot++ ;
		  goto NEXT ;
		}
	  }
NEXT: ;
	}

	el=mat[r] ;		   // pivot S̍s폜
	for( k=0 ; k<row[j][0] ; k++ ) {
	  col[icol[el[k]]][0]-- ;
	  el[k]=0 ;
	}
	row[j][0]=0 ;

	col[icol[c1]][2]=isDeleted ;
  }

  if( krow>lrow	 ) {
	QSortUSD(krow,6,4,(unsigned short*)row) ;
	for( lrow=0,j=krow-1 ; j>0 ; j-- ) {
	  if( row[j][2]>=isActive ) { lrow=j+1 ; break ; }
	}
	krow=lrow ;

	goto Step2 ;
  }

Step6: ;
  if( kcol>0 ) {
	QSortUSD(kcol,6,0,(unsigned short*)col) ;
	mcol=(kcol)>>9 ;		 // 1/512  inactive ɂ
	mcol=mcol>0 ? mcol:1 ;
	for( j=0 ; j<mcol ; j++ ) col[j][2]=notActive ;
	goto Step1 ;
  }

Step7:
  pivot.close() ;


		  // ^̗ԍ->recuded matrix ł̗ԍ
  QSortUSD(maxrow,6,4,(unsigned short*)row) ;
  for( j=0 ; j<maxrow ; j++ ) oldrow[j]=row[j][1] ;		// X̍sԍ
		 // lrow ŏIIȍs̍š
  for( lrow=0,j=maxrow-1; j>0 ; j-- ) {
	if( row[j][2]>isDeleted ) { lrow=j+1 ; break ; }
  }
		 // krow sɌ񎟎̌
  for( krow=0,j=lrow-1; j>0 ; j-- ) {
	if( row[j][2]>isPivot ) { krow=j+1 ; break ; }
  }

  QSortUSD(maxcol,6,4,(unsigned short*)col) ;
  for( kcol,j=maxcol-1 ; j>=0 ; j-- )
	if( col[j][2]>isDeleted ) { kcol=j+1 ; break ; }
  QSortUSD(kcol,6,2,(unsigned short*)col) ;
  for( j=0 ; j<maxcol ; j++ ) icol[col[j][1]]=(unsigned short)j ;

  elem.open(elemfile,ios::binary|ios::in) ;
  if( elem.bad() ) {
	cerr << endl << "Error : could not open file " << elemfile ;
	Error(file not found) ;
  }
  for( j=0 ; j<maxrow ; j++ ) {
	elem.read((char*)(nel+j),2) ;
	if( nel[j]!=0 ) elem.read((char*)mat[j],2*nel[j]) ;
  }
  elem.close() ;

  for( j=0 ; j<maxrow ; j++ ) {
	el=mat[j] ;
	for( l=0,k=0 ; k<nel[j] ; k++ ) {
	  c=icol[el[k]] ;
	  if( c<kcol ) {
		el[k]=(unsigned short)c ; // reduced matrix ɂԍɒu
		l++ ;
	  }
	  else el[k]=0 ;		// reduced matrix Ɋ֌WȂvf̂Ă
	}
	QSortUSD(nel[j],2,0,el) ;
	nel[j]=l ;
  }

  for( j=0 ; j<maxrow ; j++ ) nowrow[oldrow[j]]=(unsigned short)j ;

  delete [] row ;
  delete [] col ;

  long size	 ;
  long lbyte ;
  long nbyte ;
  long kbyte ;
  long ksize ;
  long lsize ;
//	size=krow ;
  size=kcol ;

  nbyte=((size+31)>>5)<<2 ;				   // s̃oCg
  n=1024*1024*24 ;						   // 24MB [NɎgp
  n=(size*nbyte+n-1)/n ;

  TBit V1,V2 ;
  unsigned long* p1 ;
  unsigned long* p2 ;
  kbyte=(((nbyte>>2)+n-1)/n)<<2 ;		   // őgݗĂs̃oCg	4oCgPʂɂ
  if( nbyte>kbyte*n ) n++ ;

  pivot.open(pivfile,ios::binary|ios::out|ios::in) ;

  if( pivot.bad() ) {
	cerr << endl << "Error : could not open file " << pivfile ;
	Error(file not found) ;
  }


  for( j=0 ; j<maxrow ; j++ ) isDefined[j]=false ;

//cout << endl << "reconstruct matrix " << flush ;
  mpqsmat.open(matfile,ios::binary|ios::out) ;
  cout << endl << "matrix reduction " << maxrow	 << " -> " << krow << flush ;
   // pivot ̗t@CŏIsɂƂ̍s̑gč\
  unsigned short prev ;
  for( k=0 ; k<n ; k++ ) {
	pivot.seekp(0) ;
	prev=0xffff ;
	p1=NULL ;
	p2=NULL ;
	if( nbyte<=kbyte*k+kbyte ) lbyte=nbyte-kbyte*k ;
	else lbyte=kbyte ;
	if( lbyte<=0 ) break ;
	lsize=lbyte<<3 ;							  // s
	ksize=(kbyte*k)<<3 ;						  // ς݂̍s
	for( j=0 ; j<npivot ; j++ ) {
	  pivot.read((char*)&r,2) ;
	  pivot.read((char*)&l,2) ;
	  if( !isDefined[r] ) {		// m
		if( p1 ) {				// ܂ł pivot S̍s͈ȌgpȂ
		  delete [] p1 ;		// ̂Ŏ̂Ă
		  bitmat[prev]=NULL ;
		  isDefined[prev]=false ;
		}
		p1=new unsigned long[lbyte>>2] ;

		if( !p1 ) Error(allocate error) ;
		memset(p1,'\0',lbyte) ;
		V1.SetBitString(lsize,p1) ;
		el=mat[r] ;
							  // Ήs̃rbgI
		for( c=0,ie=nel[r]-1 ; ie>=0 ; ie-- ) {
		  if( el[ie]<ksize+lsize ) {	// el[*] ͍~Ƀ\[gĂ
			c++ ;
			V1.BitOn((long)el[ie]-ksize) ;
		  }
		  else break ;
		}
		nel[r]-=c ;			  // sɑgݍ܂ꂽ entry  O
		isDefined[r]=true ;
		bitmat[r]=p1 ;
		prev=r ;
	  }
	  else {
		if( p1==bitmat[r] ) ;	// pivot S͂܂̏ɎgsƓ
		else {
		  if( p1 ) {			//  pivot S̍s͎gpȂ
			delete [] p1 ;
			bitmat[prev]=NULL ;
			isDefined[prev]=false ;
		  }
		  p1=bitmat[r] ;
		  V1.SetBitString(lsize,p1) ;
		  prev=r ;
		}
	  }

	  if( !isDefined[l] ) {		// ܂s̃mۂĂȂ
		p2=new unsigned long[lbyte>>2] ;
		if( !p2 ) Error(allocate error) ;
		memset(p2,'\0',lbyte) ;
		V2.SetBitString(lsize,p2) ;
		el=mat[l] ;
		   // lrow ȏ̍s͍ŌIɂ͍sɌȂ̂Ŗ
		for( c=0,ie=nel[l]-1 ; ie>=0 ; ie-- ) {
		  if( el[ie]<ksize+lsize ) {
			c++ ;
			V2.BitOn((long)el[ie]-ksize) ;
		  }
		  else break ;
		}
		nel[l]-=c ;
		isDefined[l]=true ;
		bitmat[l]=p2 ;
	  }
	  else {
		p2=bitmat[l] ;
		V2.SetBitString(lsize,p2) ;
	  }

	  V2^=V1 ;							// rI_a

	}

					// st@Cɏo
	V.SetBitString(lsize,v2) ;
	for( j=0 ; j<krow ; j++ ) {
	  r=oldrow[j] ;
	  if( isDefined[r] ) {
/**************
		if( j>=kcol ) {
		  if( j>=ksize && j<ksize+lsize ) {
			V1.SetBitString(lsize,bitmat[r]) ;
			V1.BitOn(j-ksize) ;
		  }
		}
**************/
		mpqsmat.seekg(nbyte*j+kbyte*k) ;
		mpqsmat.write((char*)bitmat[r],lbyte) ;
	  }
	  else {		  // inactive ɂȂs
		memset(v2,'\0',lbyte) ;
		el=mat[r] ;
		for( c=0,ie=nel[r]-1 ; ie>=0 ; ie-- ) {
		  if( el[ie]<ksize+lsize ) {
			c++ ;
			V.BitOn((long)el[ie]-ksize) ;
		  }
		  else break ;
		}
		nel[r]-=c ;
/*************
		if( j>=kcol ) {
		  if( j>=ksize && j<ksize+lsize )
			V.BitOn(j-ksize) ;
		}
************/
		mpqsmat.seekg(nbyte*j+kbyte*k) ;
		mpqsmat.write((char*)v2,lbyte) ;
	  }
	}

	for( j=maxrow-1 ; j>=0 ; j-- ) {
	  if( isDefined[j] ) { delete [] bitmat[j] ; bitmat[j]=NULL ; }
	  isDefined[j]=false ;
	}
  }

  mpqsmat.close() ;
  for( j=0 ; j<maxrow ; j++ ) {
	if( mat[j] ) delete [] mat[j] ;
  }

  size=lrow ;
  nbyte=((size+31)>>5)<<2 ;			   // s̃oCg
  n=1024*1024*32 ;					   // 32MB [NɎgp
  n=(size*nbyte+n-1)/n ;
  kbyte=(((nbyte>>2)+n-1)/n)<<2 ;	   // őgݗĂs̃oCg	4oCgPʂɂ
  if( nbyte>kbyte*n ) n++ ;

  mpqscomb.open(combfile,ios::binary|ios::out) ;
  for( k=0 ; k<n ; k++ ) {
	prev=0xffff ;
	p1=NULL ;
	p2=NULL ;
	pivot.seekp(0) ;
	if( nbyte<kbyte*k+kbyte ) lbyte=nbyte-kbyte*k ;
	else lbyte=kbyte ;
	if( lbyte<=0 ) break ;
	lsize=lbyte<<3 ;							  // 
	ksize=(kbyte*k)<<3 ;						  // ς݂̗
	for( j=0 ; j<npivot ; j++ ) {
	  pivot.read((char*)&r,2) ;
	  pivot.read((char*)&l,2) ;
	  if( !isDefined[r] ) {		// m
		if( p1 ) {				// ܂ł pivot S̍s͈ȌgpȂ
		  delete [] p1 ;		// ̂Ŏ̂Ă
		  bitmat[prev]=NULL ;
		  isDefined[prev]=false ;
		}
		p1=new unsigned long[lbyte>>2] ;

		if( !p1 ) Error(allocate error) ;
		memset(p1,'\0',lbyte) ;
		V1.SetBitString(lsize,p1) ;
							  // Ήs̃rbgI
		if( nowrow[r]<lrow ) {
		  if( nowrow[r]>=ksize && nowrow[r]<ksize+lsize ) {
			V1.BitOn((long)nowrow[r]-ksize) ;
		  }
		}
		isDefined[r]=true ;
		bitmat[r]=p1 ;
		prev=r ;
	  }
	  else {
		if( p1==bitmat[r] ) ;	// pivot S͂܂̏ɎgsƓ
		else {
		  if( p1 ) {			//  pivot S̍s͎gpȂ
			delete [] p1 ;
			bitmat[prev]=NULL ;
			isDefined[prev]=false ;
		  }
		  p1=bitmat[r] ;
		  V1.SetBitString(size,p1) ;
		  prev=r ;
		}
	  }

	  if( !isDefined[l] ) {		// ܂s̃mۂĂȂ
		p2=new unsigned long[lbyte>>2] ;
		if( !p2 ) Error(allocate error) ;
		memset(p2,'\0',lbyte) ;
		V2.SetBitString(lsize,p2) ;
		 // lrow ȏ̍s͍ŌIɂ͍sɌȂ̂Ŗ
		if( nowrow[l]<lrow ) {
		  if( nowrow[l]>=ksize && nowrow[l]<ksize+lsize ) {
			V2.BitOn((long)nowrow[l]-ksize) ;
		  }
		}
		isDefined[l]=true ;
		bitmat[l]=p2 ;
	  }
	  else {
		p2=bitmat[l] ;
		V2.SetBitString(size,p2) ;
	  }
	  V2^=V1 ;							// rI_a
	}
					// st@Cɏo
	for( j=0 ; j<krow ; j++ ) {
	  r=oldrow[j] ;
	  if( isDefined[r] ) {
		mpqscomb.seekg(nbyte*j+kbyte*k) ;
		mpqscomb.write((char*)bitmat[r],lbyte) ;
	  }
	  else {		  // inactive ɂȂs
		memset(v2,'\0',lbyte) ;
		if( nowrow[r]<lrow ) {
		  if( nowrow[r]>=ksize && nowrow[r]<ksize+lsize ) {
			V.BitOn((long)nowrow[r]-ksize) ;
		  }
		}
		mpqscomb.seekg(nbyte*j+kbyte*k) ;
		mpqscomb.write((char*)v2,lbyte) ;
	  }
	}

	for( j=maxrow-1 ; j>=0 ; j-- ) {
	  if( isDefined[j] ) { delete [] bitmat[j] ; bitmat[j]=NULL ; }
	  isDefined[j]=false ;
	}
  }

  pivot.close() ;
  mpqscomb.close() ;

  nrow=krow ;
  ncol=kcol ;
}

