//
//  Copyright (C) by S.Tomabechi 1993-1997
//  All rights reserved.
//
//  ]߂  ( a bŊƂ̗])
//
//  RemType=0 residue with same sign of a
//  RemType=1 the smallest nonnegative residue  i.e. a-[a/b]*b
//            min { r>0 | r=a-q*b }
//  RemType=2 the smallest residue in absolute value
//
#ifdef __BORLANDC__
#pragma inline
#endif

#ifndef __cplusplus
#error Must use C++ for the type Mint
#endif

#define _ONLY_MINTDECL_
#include "Mint.hpp"
#include "Error.hpp"

Mint& Mint::isRem22(const Mint& a,const Mint& b,int RemType)
{
#ifdef _MEMMAN_DEBUG
a.check(__FILE__,__LINE__) ;
b.check(__FILE__,__LINE__) ;
#endif

  int bnDigit ;

  __asm {
    mov eax,b
#ifdef __BORLANDC__
    mov edx,dword ptr [eax].nDigit
#else
    mov edx,dword ptr [eax][NDIGIT]
#endif
    mov bnDigit,edx
    or  edx,edx                      // b=0 ?
    jnz NOT_ZERO
  }

  Error(zero divide) ;              // b=0 Ŋ낤Ƃ

  int anDigit ;
  signed char sign ;                // a ̕
NOT_ZERO:
  __asm {
    mov eax,a
#ifdef __BORLANDC__
    mov ecx,dword ptr [eax].nDigit
    mov dl,byte ptr [eax].nDim[3]
#else
    mov ecx,dword ptr [eax][NDIGIT]
    mov dl,byte ptr [eax][SIGN]
#endif
    mov anDigit,ecx
    mov sign,dl
  }

  if( bnDigit==1 ) {    // b ꌅ̐Ȃȉ̃ASY͓Kps
    if( (*digit=a.isRemUL(*b.digit,RemType))==0 )
      nDim&=_POSITIVE_ ; //  <- 1
    else if( RemType==SameSignRem )
      (nDim&=_DIGITS_)|=((unsigned long)sign)<<24 ;   // a Ɠ
    else if( RemType==PositiveRem ) nDim&=_POSITIVE_ ;// 
    else {
      if( *digit<=(((unsigned long)b)/2) )            // Βlr
        nDim&=_POSITIVE_ ;
      else {
        *digit=(*b.digit)-(*digit) ;
        nDim|=_NEGATIVE_ ;
      }
    }
    if( *digit ) nDigit=1 ;
    else nDigit=0 ;
#ifdef _MEMMAN
check(__FILE__,__LINE__) ;
#endif
    return *this ;
  }

  if( anDigit<bnDigit ) {
    if( this!=&a ) *this=a ;
    switch( RemType ) {
      case PositiveRem:                           // ŏ]
        if( sign<0 ) {
          if( b.isPositive() ) *this+=b ;
          else *this-=b ;
        }
        break ;
      case AbsoluteRem:                           // ΍ŏ]
        if( bnDigit==anDigit+1 ) {
          _uMtemp=b ;
          if( _uMtemp.isNegative() ) {
#ifdef __BORLANDC__
            __asm {
              mov byte ptr [@Mint@_uMtemp].nDim[3],1   // 
            }
#else
            _uMtemp.nDim&=_POSITIVE_ ;
#endif
          }
          _vMtemp.isShiftr(_uMtemp,1) ;
#ifdef _MEMMAN_DEBUG
_vMtemp.check(__FILE__,__LINE__) ;
check(__FILE__,__LINE__) ;
#endif
          __asm {
            mov  eax,a                        // ꎞI a 𐳐ɂ
#ifdef __BORLANDC__
            mov  byte ptr [eax].nDim[3],1
#else
            mov  byte ptr [eax][SIGN],1
#endif
          }
          if( _vMtemp<a ) {                  // ̑삪KvȃP|X͏Ȃ
            if( sign>0 ) *this-=_uMtemp ;
            else *this+=_uMtemp ;
          }
          __asm {                            // Ƃ̕ɖ߂
             mov  eax,a
             mov  cl,sign
#ifdef __BORLANDC__
             mov  byte ptr [eax].nDim[3],cl
#else
             mov  byte ptr [eax][SIGN],cl
#endif
          }
        }
        break ;
      default:
       break ;
    }
#ifdef _MEMMAN
check(__FILE__,__LINE__) ;
#endif
    return *this ;
  }

  int shift(31) ;
  unsigned long q,res ;
  unsigned long v1,v2 ;
  unsigned long j4 ;
  unsigned long j_n4 ;
  int Count ;
  unsigned long ui,vi ;  // CfbNXZ[ü

  if( ndim()<anDigit+1 ) {       // Kvȑ傫m
    if( this==&a || this==&b ) reallocate(anDigit+1) ;
    else allocate(anDigit+1) ;
  }

#ifdef _MEMMAN
_MemMan.check(__FILE__,__LINE__) ;
#endif

  if( _vMtemp.ndim()<bnDigit ) _vMtemp.allocate(bnDigit) ;
#ifndef __BORLANDC__
  unsigned long* vptr ;
    vptr=Mint::_vMtemp.digit ;
#endif

D1:
  __asm {
#ifdef __BORLANDC__
    mov   esi,dword ptr [@Mint@_vMtemp].digit
    mov   edi,this
    mov   edi,dword ptr [edi].digit
#else
    mov   esi,vptr
    mov   edi,this
    mov   edi,dword ptr [edi][DIGIT]
#endif

    mov   dword ptr ui,edi   // xAhXƂ蒼ׂ͕̂ɂȂ̂
    mov   dword ptr vi,esi   // CfbNXWX^oĂ

    mov   edi,b
#ifdef __BORLANDC__
    mov   edi,dword ptr [edi].digit
#else
    mov   edi,dword ptr [edi][DIGIT]
#endif
    mov   ebx,bnDigit        // v̌
    bsr   ecx,dword ptr [ebx*NBYTE][edi][-NBYTE]
    sub   shift,ecx
    mov   ecx,shift          // Vtg
  }
  __asm {
    mov   eax,dword ptr [edi][ebx*NBYTE][-NBYTE]
  }
mult_vd:                      // 傫 _vMtemp=b<<shift
  __asm {
    dec   ebx
    jz    EXIT1
    mov   edx,eax
    mov   eax,dword ptr [edi][ebx*NBYTE][-NBYTE]
    shld  edx,eax,cl
    mov   dword ptr [esi][ebx*NBYTE],edx
    jmp   mult_vd
  }
EXIT1:
  __asm {
    shl   eax,cl
    mov   dword ptr [esi],eax

    mov   edi,a
#ifdef __BORLANDC__
    mov   edi,dword ptr [edi].digit
#else
    mov   edi,dword ptr [edi][DIGIT]
#endif


    mov   esi,ui
    mov   ebx,anDigit // a ̌
    xor   edx,edx
    mov   eax,dword ptr [edi][ebx*NBYTE][-NBYTE]
    shld  edx,eax,cl
    mov   dword ptr [esi][ebx*NBYTE],edx
  }
mult_ud:                      // 폜傫
  __asm {
    dec   ebx
    jz    EXIT2
    mov   edx,eax
    mov   eax,dword ptr [edi][ebx*NBYTE][-NBYTE]
    shld  edx,eax,cl
    mov   dword ptr [esi][ebx*NBYTE],edx
    jmp   mult_ud
  }
EXIT2:
  __asm {
    shl   eax,cl
    mov   dword ptr [esi],eax

  }
D2:
  __asm {                       // 
    mov   ebx,bnDigit   // b̌
    mov   edi,vi
    mov   eax,dword ptr [ebx*NBYTE][edi][-NBYTE]
    mov   v1,eax      // v̍ŏʌ
    mov   eax,dword ptr [ebx*NBYTE][edi][-2*NBYTE]
    mov   v2,eax      // v̎̌

    mov   eax,anDigit   // ǔ
    mov   j4,eax
    sub   eax,ebx
    shl   eax,2
    mov   j_n4,eax
  }

D3:
  __asm {
    mov   ebx,j4
    mov   esi,ui
    mov   edx,dword ptr [ebx*NBYTE][esi] // dx=u[j]
    cmp   edx,v1
    jne   not_equal
    mov   eax,0ffffffffh         // u[j]==v1
    mov   q,eax
    mov   ecx,dword ptr [ebx*NBYTE][esi][-NBYTE]
  }
test0:
  __asm {
    add   ecx,v1
    jc    D4
    mov   res,ecx
    jmp   test
  }
not_equal:
  __asm {
    mov   eax,dword ptr [ebx*NBYTE][esi][-NBYTE]
    div   v1
    mov   q,eax     // q=
    mov   res,edx   // res=]
  }
test:
  __asm {
    mov   eax,v2
    mul   q
    mov   ecx,dword ptr [ebx*NBYTE][esi][-2*NBYTE]
    sub   ecx,eax
    mov   ecx,res
    sbb   ecx,edx
    jnc   D4
  }
q_1:
  __asm {
    dec   q
    jmp   test0
  }
D4:
  __asm {                       // u-q*v
    mov   edi,vi
    mov   ecx,bnDigit
    mov   esi,ui

    add   esi,j_n4
    mov   Count,ecx
    xor   ecx,ecx               // ecx=Overflow
    mov   ebx,ecx               // ebx=carry
  }
mult:
  __asm {
    mov   eax,dword ptr [edi]
    lea   edi,[edi][NBYTE]      // carry flag ωȂ
    mul   q
    add   eax,ecx
    adc   edx,0                 // carry 
    mov   ecx,edx               // ӂZ[u
  }
next1:
  __asm {
    add   eax,ebx
    adc   ecx,0
    sbb   dword ptr [esi],eax
    mov   ebx,0
    adc   ebx,0
    lea   esi,[esi][NBYTE]
    dec   Count
    jnz   mult
    mov   eax,ecx
    mov   ecx,0
    add   eax,ebx
    adc   ecx,0
    sbb   dword ptr [esi],eax
    adc   ecx,0
  }
D5:
  __asm {
    jecxz D7                    // ̌ւ̎؂肪
  }
D6:
  __asm {                       // ߂̂ŉ߂
    mov   ecx,bnDigit
    mov   edi,vi
    mov   esi,ui
    add   esi,j_n4
    xor   ebx,ebx
  }
Sub_loop:
  __asm {
    mov   eax,dword ptr [ebx*NBYTE][edi]
    adc   dword ptr [ebx*NBYTE][esi],eax
    inc   ebx
    dec   ecx
    jnz   Sub_loop
//    mov   eax,0
//    adc   dword ptr [ebx*NBYTE][esi],eax
    jnc   D7
    inc   dword ptr [ebx*NBYTE][esi]
  }
D7:
  __asm {
    cmp   j_n4,0
    jle   D8
    sub   j_n4,NBYTE
    dec   j4
    jmp   D3
  }
D8:
  __asm {
    mov   esi,ui
    mov   ebx,bnDigit
    mov   ecx,shift
//jecxz Search0
    mov   eax,dword ptr [esi]
  }
Renormalize:         // ֏Vtg]EփVtg
  __asm {
    dec   ebx
    jz    EXIT3
    mov   edx,eax
    mov   eax,dword ptr [esi][NBYTE]
    shrd  edx,eax,cl
    mov   dword ptr [esi],edx
    lea   esi,[esi][NBYTE]
    jmp   Renormalize
  }
EXIT3:
  __asm {
    shr   eax,cl
    mov   dword ptr [esi],eax
  }
Search0:
  __asm {
    mov   ebx,bnDigit
  }
Search_nonZero:
  __asm {
    cmp   dword ptr [esi],0
    jne   nonZero                         // 0 ?
    lea   esi,[esi][-NBYTE]
    dec   ebx
    jnz   Search_nonZero
    jmp   SetZero
  }
nonZero:
  __asm {
    cmp   RemType,SameSignRem    // ߂̂͒ʏ̏]
    je    SetDigit
  }
  __asm {
    mov   esi,ui
    mov   edi,b
#ifdef __BORLANDC__
    mov   edi,dword ptr [edi].digit
#else
    mov   edi,dword ptr [edi][DIGIT]
#endif

    cmp   RemType,PositiveRem    // ߂͍̂ŏ] ?
    je    PosRem
    mov   ecx,ebx                //  ecx ɕۑ
    mov   ebx,bnDigit            // Βlŏ]߂
    xor   edx,edx
  }
Compare:                         // |b|/2 Ɣr
  __asm {
    mov   eax,dword ptr [ebx*NBYTE][edi][-NBYTE]  // |b|/2>|r| ?
    shrd  eax,edx,1
    cmp   eax,dword ptr [ebx*NBYTE][esi][-NBYTE]    // |b|/2 Ɣr
    jb    Less                              // |b|/2<|r|
    ja    Greater                           // |b|/2>|r|
    mov   edx,dword ptr [ebx*NBYTE][edi][-NBYTE]
    dec   ebx
    jnz   Compare
  }
Greater:
  __asm {
    mov   ebx,ecx                           // Zbg
    jmp   SetDigit                          // |b|/2>=|r| 
  }
PosRem:
  __asm {
    cmp   sign,0                   //  ?
    jge   SetDigit                 // ȂI
  }
Less:
  __asm {
    mov   ecx,bnDigit               // |b|-|r| vZ
    xor   ebx,ebx
  }
subloop:                                  // |b|-|r| vZ
  __asm {
    mov   eax,dword ptr [ebx*NBYTE][edi]
    sbb   eax,dword ptr [ebx*NBYTE][esi]
    mov   dword ptr [ebx*NBYTE][esi],eax
    inc   ebx
    dec   ecx
    jnz   subloop
    neg   sign                     // 𔽓]
    mov   RemType,SameSignRem
    lea   esi,[esi][ebx*NBYTE][-NBYTE]
    jmp   Search_nonZero                    // ă`FbN
  }
SetZero:
  __asm {
    mov   sign,1
    xor   ebx,ebx
  }
SetDigit:
  __asm {
    mov   edi,this

    mov   cl,sign
#ifdef __BORLANDC__
    mov   byte ptr [edi].nDim[3],cl
    mov   dword ptr [edi].nDigit,ebx
#else
    mov   byte ptr [edi][SIGN],cl
    mov   dword ptr [edi][NDIGIT],ebx
#endif

  }

RET1:
#ifdef _MEMMAN_DEBUG
check(__FILE__,__LINE__) ;
//_vMtemp.check(__FILE__,__LINE__) ;
//_MemMan.check(__FILE__,__LINE__) ;
#endif
  return *this ;

}

